// cc_analysis
// created: 01-31-2011
// author:  RF
// last modification: 01-31-2011

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <string.h>
#include <fcntl.h>
#include <io.h>
#include <share.h>
#include <math.h>

//LabWindows
#include "C:\cvi401\include\cvirte.h"
#include "C:\cvi401\include\analysis.h"

// WT_A include files used
#include "CC_POST_PROCESSING_defines.h"
#include "CC_POST_PROCESSING_global_variables.h"
#include "CC_POST_PROCESSING_input.h"
#include "CC_POST_PROCESSING_functions.h"
#include "CC_POST_PROCESSING_plume_functions.h"
#include "CC_POST_PROCESSING_puff_functions.h"



void main(int argc, char *argv[])
{
    if (argc < 2) {
        printf("\n\n\a\a\a wrong program call!\n");
        printf("\n program will be aborted!\n");
        while (!kbhit());
        exit(1);
    }

    strcpy(filename, argv[1]);


    // open and read logbook-info file:
    open_read_logbook_info();



    /********* standard values for parameters **********************/

    meas_point      = 000;
    strcpy(ts_number, "00");
    sample_freq     = 1000.;
    down_sampling   = 1.;
    blcksz          = 10;
    t_open          = 1.;
    x_pos_mea       = 999.999;
    y_pos_mea       = 999.999;
    z_pos_mea       = 999.999;
    model_scale     = 1;
    scale_factor    = 1.;
    ref_height      = 1.;
    threshold       = 999.999;
    time_needle     = 0.111;
    offset_time     = 0.2;
    offset_plume    = 0.;
    temperature     = 21.;
    pressure        = 760.;
    reproducibility = 999.99;
    
    
    /***************************************************************/

    if (argc > 1) {                                                     //frher: argc >=2
        string_2[0] = '\0';
        for (i=1; i<argc; i++) {                                        //frher: i=2
            strncpy(string_1, argv[i], CODESIZE);
            k = 0;
            for (j = CODESIZE; j <= strlen(argv[i]); j++) {
                string_2[k] = argv[i][j];
                k++;
            }

            if (strcmp(string_1, "INPUTF:")==NULL||strcmp(string_1, "inputf:")==NULL)
                strcpy(input_file, string_2);
            if (strcmp(string_1, "POINT_:")==NULL||strcmp(string_1, "point_:")==NULL)
                meas_point = atoi(string_2);
            if (strcmp(string_1, "NUMBER:")==NULL||strcmp(string_1, "number:")==NULL)
                strcpy(ts_number, string_2);    
            if (strcmp(string_1, "SAMPLE:")==NULL||strcmp(string_1, "sample:")==NULL)
                sample_freq = atof(string_2);
            if (strcmp(string_1, "D_SAMP:")==NULL||strcmp(string_1, "d_samp:")==NULL)
                down_sampling = atof(string_2);
            if (strcmp(string_1, "BLCKSZ:")==NULL||strcmp(string_1, "blcksz:")==NULL)
                blcksz = atoi(string_2);
            if (strcmp(string_1, "T_OPEN:")==NULL||strcmp(string_1, "t_open:")==NULL)
                t_open = atof(string_2);    
            if (strcmp(string_1, "X_MEAS:")==NULL||strcmp(string_1, "x_meas:")==NULL)
                x_pos_mea = atof(string_2);
            if (strcmp(string_1, "Y_MEAS:")==NULL||strcmp(string_1, "y_meas:")==NULL)
                y_pos_mea = atof(string_2);
            if (strcmp(string_1, "Z_MEAS:")==NULL||strcmp(string_1, "z_meas:")==NULL)
                z_pos_mea = atof(string_2);
            if (strcmp(string_1, "SCALE_:")==NULL||strcmp(string_1, "scale_:")==NULL)
                model_scale = atoi(string_2);
            if (strcmp(string_1, "SC_FAC:")==NULL||strcmp(string_1, "sc_fac:")==NULL)
                scale_factor = atof(string_2);
            if (strcmp(string_1, "REFHGT:")==NULL||strcmp(string_1, "refhgt:")==NULL)
                ref_height = atof(string_2);
            if (strcmp(string_1, "REFLTH:")==NULL||strcmp(string_1, "reflth:")==NULL)
                ref_length = atof(string_2);    
            if (strcmp(string_1, "THRHLD:")==NULL||strcmp(string_1, "thrhld:")==NULL)
                threshold = atof(string_2);
            if (strcmp(string_1, "T_NDLE:")==NULL||strcmp(string_1, "t_ndle:")==NULL)
                time_needle = atof(string_2);           
            if (strcmp(string_1, "T_OFFS:")==NULL||strcmp(string_1, "t_offs:")==NULL)
                offset_time = atof(string_2);
            if (strcmp(string_1, "P_OFFS:")==NULL||strcmp(string_1, "p_offs:")==NULL)
                offset_plume = atof(string_2);
            if (strcmp(string_1, "TEMP__:")==NULL||strcmp(string_1, "temp__:")==NULL)
                temperature = atof(string_2);
            if (strcmp(string_1, "PRESS_:")==NULL||strcmp(string_1, "press_:")==NULL)
                pressure = atof(string_2);
            if (strcmp(string_1, "REPRO_:")==NULL||strcmp(string_1, "repro_:")==NULL)
                reproducibility = atof(string_2);    
            if (strcmp(string_1, "COEF_A:")==NULL||strcmp(string_1, "coef_a:")==NULL)
                coefficient_a = atof(string_2);
            if (strcmp(string_1, "COEF_B:")==NULL||strcmp(string_1, "coef_b:")==NULL)
                coefficient_b = atof(string_2);
                                           
                     
            //printf("string_: %s\n",string_2);    
            string_2[0] = '\0';
            //printf("string_: %s\n",string_2);                                     
        }
    }

    pressure = (pressure * (101325./760.))/100.;

    //printf("windd: %lf\n", windd);

    printf("\n\n\n *******************************************\n");
    printf(" *     W I N D   T U N N E L - D A T A     *\n");
    printf(" *             A N A L Y S I S             *\n");
    printf(" *                                         *\n");
    printf(" *           CC POST PROCESSING            *\n");
    printf(" * --------------------------------------- *\n");
    printf(" * author: R. Fischer                      *\n");
    printf(" * e-mail: rasmus.fischer@zmaw.de          *\n");
    printf(" *******************************************\n\n\n");

    printf("\n\n The adjustments of this run are:\n\n");
    printf(" input-file                 : %s\n", input_file);
    printf(" main project name          : %s\n", str_maincamp);
    printf(" sub project name           : %s\n", str_subcamp);
    printf(" wind tunnel                : %s\n", str_wt);
    printf(" model-scale                : %i\n", model_scale);             
    printf(" scale-factor               : %lf\n", scale_factor);             
    printf(" reference height           : %5.3lf [m]\n", ref_height);
    printf(" wind direction             : %5.1lf [deg]\n", atoi(str_winddir)/10.);         
    printf(" type of measurement        : %s\n", str_meastype);      
    printf(" name of source             : %s\n", str_source);
    printf(" released gas               : %s\n", str_tracer);
    printf(" threshold                  : %5.2lf [ppmvs]\n", threshold);         
    printf(" sampling frequency         : %5.2lf [Hz]\n", sample_freq);
    printf(" block size                 : %i\n", blcksz);       
    printf(" time correction            : %5.3lf [s]\n", time_needle);                
    printf(" x-position for release     : %s [mm]\n", str_xsource);             
    printf(" y-position for release     : %s [mm]\n", str_ysource);             
    printf(" z-position for release     : %s [mm]\n", str_zsource);             
    printf(" x-position for measurement : %5.1lf [mm]\n", x_pos_mea);             
    printf(" y-position for measurement : %5.1lf [mm]\n", y_pos_mea);             
    printf(" z-position for measurement : %5.1lf [mm]\n", z_pos_mea);
    printf(" coefficient a              : %5.2lf [(l/h)/V]\n", coefficient_a);
    printf(" coefficient b              : %5.2lf [l/h]\n\n\n", coefficient_b);     
    

    
    // open timeseries:
    open_timeseries();

    // load timeseries:
    load_timeseries();

    // calculating the effective concentration:
    calc_cef();

    //puff_output_ceff_check();

    
    if(strcmp(str_meastype_cc, "puff") == 0 || strcmp(str_meastype_cc, "PUFF") == 0) {

        // extract releases:
        extract_releases_puff();

        //puff_output_coffs_check();
        
        // detection of release duration:
        detect_rel_dur_puff();

        // correction of signal-offset:
        correct_sig_offset_puff();

        //puff_output_ccorr_check();

        // block-averaging:
        blck_ave_puff();

        //puff_output_ave_check();

        // rejection of not detected concentration signals:
        reject_signals();

        // data output:
        data_output_puff();

        //puff_output_sort_check();
        //puff_output_vol_flow_check();
    }


    if(strcmp(str_meastype_cc, "plume") == 0 || strcmp(str_meastype_cc, "PLUME") == 0) {

        // correction of signal-offset:
        correct_sig_offset_plume();
        
        // block-averaging:
        blck_ave_plume();

        //plume_output_ave_check();

        // data output:
        data_output_plume();
    }
    
    
    
    printf("\n\n\n Goodbye!\n");
}


