// cc_analysis_plume_functions
// created: 02-10-2011
// author:  RF
// last modification: 02-10-2011







void correct_sig_offset_plume() {
    
    /*********************** SIGNAL-OFFSET CORRECTION *******************/

    for(count = 0; count < samples; count++) {
        ccorr[count]  = cef[count]-offset_plume;
    }

    /*******************************************************************/
}











void blck_ave_plume() {

    Releasenumber   = 0;
    count           = 0;
    blocknumber     = 0;
    blocknumber_max = (int)(samples/blcksz);
    do {
        block_count = 0;
        sum_tt      = 0.0;
        sum_tt_int  = 0.0;
        sum_upt     = 0.0;
        sum_cb      = 0.0;
        sum_c       = 0.0;
        sum_cef     = 0.0;
        sum_qsource = 0.0;
        sum_trig    = 0.0;
        sum_ccorr   = 0.0;

        do {
            sum_tt      = sum_tt      + tt[count];
            sum_upt     = sum_upt     + upt[count];
            sum_cb      = sum_cb      + cb[count];
            sum_c       = sum_c       + c[count];
            sum_cef     = sum_cef     + cef[count];
            sum_qsource = sum_qsource + qsource[count];
            sum_trig    = sum_trig    + trig[count];
            sum_ccorr   = sum_ccorr   + ccorr[count];
            
            //printf("count: %i  block count: %i  tt[%i]: %lf  blck: %i  blck_max: %i\n", Releaseindex, block_count, Releaseindex, Releasedata_raw[Releasenumber][1][Releaseindex], blocknumber, blocknumber_max);
             
            block_count++;
            count++;
        } while (block_count < blcksz);

        Releasedata_ave[Releasenumber][1][blocknumber] = sum_tt/blcksz;
        Releasedata_ave[Releasenumber][2][blocknumber] = sum_tt_int/blcksz;
        Releasedata_ave[Releasenumber][3][blocknumber] = sum_upt/blcksz;    
        Releasedata_ave[Releasenumber][4][blocknumber] = sum_cb/blcksz;    
        Releasedata_ave[Releasenumber][5][blocknumber] = sum_c/blcksz;    
        Releasedata_ave[Releasenumber][6][blocknumber] = sum_cef/blcksz;    
        Releasedata_ave[Releasenumber][7][blocknumber] = sum_qsource/blcksz;    
        Releasedata_ave[Releasenumber][8][blocknumber] = sum_trig/blcksz;    
        Releasedata_ave[Releasenumber][9][blocknumber] = sum_ccorr/blcksz;    

        //printf("tt_mean[%i]: %lf\n", blocknumber, Releasedata_ave[Releasenumber][1][blocknumber]);
        
        blocknumber++;
    } while(blocknumber < blocknumber_max);
}














void plume_output_ave_check() {

    mkdir("ave_check");

    sprintf(output_puff02, "ave_check\\%s.dts", input_file);
 
    fh = fopen(output_puff02, "w");

    fprintf(fh, "VARIABLES = \"t [s]\" \"c [ppmv]\" \"c<sub>b</sub> [ppmv]\" \"c<sub>eff</sub> [ppmv]\" \"c<sub>corr</sub> [ppmv]\" \"u<sub>P</sub> [m/s]\" \"q<sub>S</sub> [V]\" \"trigger [V]\"\n");


    Releasenumber   = 0;
    
    blocknumber = 0;

    Blocknumber_Max[Releasenumber] = (int)((Releaselength[Releasenumber])/blcksz)-1;       
                
    fprintf(fh, "ZONE T=\"plume-release\"\n");

    do {
        fprintf(fh, "%5.3lf   %5.1lf   %5.1lf   %5.1lf   %5.1lf   %5.2lf   %5.2lf   %5.2lf\n",
                    Releasedata_ave[Releasenumber][1][blocknumber], Releasedata_ave[Releasenumber][5][blocknumber],
                    Releasedata_ave[Releasenumber][4][blocknumber], Releasedata_ave[Releasenumber][6][blocknumber],
                    Releasedata_ave[Releasenumber][9][blocknumber], Releasedata_ave[Releasenumber][3][blocknumber],
                    Releasedata_ave[Releasenumber][7][blocknumber], Releasedata_ave[Releasenumber][8][blocknumber]);
            
                   
        
        blocknumber++;
    } while (blocknumber < blocknumber_max);
                    
        
    close(fh);
}















void data_output_plume() {
    
    /************************ DATA-OUTPUT *********************************/

    
    volume_flow = gcf * (0.001/3600) * ((Qsource * coefficient_a) + coefficient_b) * ((101325. * (273.15 + temperature))/(273.15 * (100. * pressure)));
    released_volume = volume_flow * trig_time_plume;

    //printf("volume flow: %10.8lf\n", volume_flow);

    mkdir("TS");

    if (meas_point <= 999 && meas_point > 99) {
        strcpy(point_string, "");
    }
    if (meas_point <= 99 && meas_point > 9) {
        strcpy(point_string, "0");
    }
    if (meas_point <= 9 && meas_point >= 0) {
        strcpy(point_string, "00");
    }

 

    if ((int)((z_pos_mea/10)*model_scale) > 9999 && (int)((z_pos_mea/10)*model_scale) <= 99999) {
        strcpy(z_string, "");
    }
    if ((int)((z_pos_mea/10)*model_scale) > 999 && (int)((z_pos_mea/10)*model_scale) <= 9999) {
        strcpy(z_string, "0");
    }
    if ((int)((z_pos_mea/10)*model_scale) > 99 && (int)((z_pos_mea/10)*model_scale) <= 999) {
        strcpy(z_string, "00");
    }
    if ((int)((z_pos_mea/10)*model_scale) > 9 && (int)((z_pos_mea/10)*model_scale) <= 99) {
        strcpy(z_string, "000");
    }
    if ((int)((z_pos_mea/10)*model_scale) >= 0 && (int)((z_pos_mea/10)*model_scale) <= 9) {
        strcpy(z_string, "0000");
    }

 

    //printf("1WINDD: %lf\n", windd);
    //printf("1WINDD: %i\n", (int) (windd*10));
    if ((int)(windd*10) > 999 && (int)(windd*10) <= 9999) {
        strcpy(windd_string, "");
    }
    if ((int)(windd*10) > 99 && (int)(windd*10) <= 999) {
        strcpy(windd_string, "0");
    }
    if ((int)(windd*10) > 9 && (int)(windd*10) <= 99) {
        strcpy(windd_string, "00");
    }
    if ((int)(windd*10) >= 0 && (int)(windd*10) <= 9) {
        strcpy(windd_string, "000");
    }
    //printf("2WINDD: %lf\n", windd);
    //printf("2WINDD: %i\n", (int) (windd*10));

    if (reproducibility == 999.99) {
        reproducibility = reproducibility;
    }
    if (reproducibility != 999.99) {
        reproducibility = (reproducibility*U_ref*pow(ref_length,2)/(volume_flow))/1000000.;
    }
    
    //printf("%s\n", str_source);
    sprintf(output_TIMESERIES, "TS\\%s_WD%s%i_P%s%i_Z%s%i_%s_nd.dts", str_source, windd_string, (int)(windd*10), point_string, meas_point, z_string, (int)((z_pos_mea/10)*model_scale), ts_number);
 
    //printf("TEST3: %lf %lf\n", Releasedata_ave[5][6][20], Releasedata_ave[5][9][20]);
 
    fh = fopen(output_TIMESERIES, "w");

 

           fprintf(fh, "# EWTL post-processed puff dispersion measurement\n");
           fprintf(fh, "# \n");
           fprintf(fh, "# ********** DATA DESCRIPTION **********\n");
           fprintf(fh, "# \n# \n# \n# \n# \n");
           fprintf(fh, "# ********** GENERAL INFORMATION **********\n");
           fprintf(fh, "# %s [main project name]\n", str_maincamp);
           fprintf(fh, "# %s [sub project name]\n", str_subcamp);
           fprintf(fh, "# %s [wind tunnel facility]\n", str_wt);
           fprintf(fh, "# 1:%i [model scale]\n", model_scale);
           fprintf(fh, "# %0.1lf [zref - model scale [mm]]\n", ref_height*1000.);
           fprintf(fh, "# %0.2lf [zref - full scale [m]]\n", ref_height*model_scale);        
           fprintf(fh, "# %0.2lf [Uref - model [m/s]]\n", U_ref);
           fprintf(fh, "# %0.2lf [wind direction []]\n", windd);
           fprintf(fh, "# %5.4lf [Lref - model scale [m]]\n", ref_length/model_scale);
           fprintf(fh, "# %5.1lf [Lref - full scale [m]]\n", ref_length);
           //fprintf(fh, "14 [utm zone]\n");
           //fprintf(fh, "PLEASE NOTE: The X-axis of the wind tunnel reference system is always aligned with the corresponding mean wind direction of the approach flow! see readme.txt \n");
           
           fprintf(fh, "# \n# \n# \n# \n# \n# \n# \n# \n# \n# \n");

           fprintf(fh, "# ********** FLOW MEASUREMENTS **********\n");
           fprintf(fh, "# # [measurement type]\n");
           fprintf(fh, "# # [number of columns]\n");
           fprintf(fh, "# # [labels]\n");
           fprintf(fh, "# # [measured components]\n");
           fprintf(fh, "# # [measurement location X - model scale [mm]]\n");  
           fprintf(fh, "# # [measurement location Y - model scale [mm]]\n");  
           fprintf(fh, "# # [measurement location Z - model scale [mm]]\n");  
           fprintf(fh, "# # [measurement location X - full scale [m]]\n");  
           fprintf(fh, "# # [measurement location Y - full scale [m]]\n");  
           fprintf(fh, "# # [measurement location Z - full scale [m]]\n");
           fprintf(fh, "# # [measurement location utm Easting [m]]\n");
           fprintf(fh, "# # [measurement location utm Northing [m]]\n");
           fprintf(fh, "# # [confidence intervall {U,V,W}/Uref[-]]\n");
        
           fprintf(fh, "# \n# \n# \n# \n# \n# \n# \n# \n# \n# \n");

           fprintf(fh, "# ********** CONCENTRATION MEASUREMENTS **********\n");
           fprintf(fh, "# %s plume [measurement type]\n", str_meastype);
           fprintf(fh, "# 2 [number of columns]\n");
           fprintf(fh, "# \"T*\" \"C*\" [labels]\n");
           fprintf(fh, "# %s [released gas]\n", str_tracer);
           fprintf(fh, "# %0.2lf [source strength [l/h]]\n", volume_flow/(0.001/3600));
           fprintf(fh, "# \"continuous release\" [release duration [s]]\n");
           fprintf(fh, "# \"continuous release\" [number of released puffs]\n");
           fprintf(fh, "# \"continuous release\" [number of detected puffs, which dosage exceeds the dosage threshold]\n");
           fprintf(fh, "# \"continuous release\" [dosage threshold - model scale [ppmvs]]\n");
           fprintf(fh, "# %0.2lf [source location X - model scale [mm]]\n", x_pos_rel);
           fprintf(fh, "# %0.2lf [source location Y - model scale [mm]]\n", y_pos_rel);
           fprintf(fh, "# %0.2lf [source location Z - model scale [mm]]\n", z_pos_rel);
           fprintf(fh, "# %0.2lf [source location X - full scale [m]]\n", (x_pos_rel/1000)*model_scale);
           fprintf(fh, "# %0.2lf [source location Y - full scale [m]]\n", (y_pos_rel/1000)*model_scale);
           fprintf(fh, "# %0.2lf [source location Z - full scale [m]]\n", (z_pos_rel/1000)*model_scale);
           fprintf(fh, "# # [source location utm Easting [m]]\n");//, 634606 - ((((x_pos_rel/1000)*model_scale)*sin((180-windd)*(3.14159/180))) + (((y_pos_rel/1000)*model_scale)*cos((180-windd)*(3.14159/180)))));
           fprintf(fh, "# # [source location utm Northing [m]]\n");//, 3926044 + (((x_pos_rel/1000)*model_scale)*cos((180-windd)*(3.14159/180))) - (((y_pos_rel/1000)*model_scale)*sin((180-windd)*(3.14159/180))));
           fprintf(fh, "# %0.2lf [measurement location X - model scale [mm]]\n", x_pos_mea);
           fprintf(fh, "# %0.2lf [measurement location Y - model scale [mm]]\n", y_pos_mea);
           fprintf(fh, "# %0.2lf [measurement location Z - model scale [mm]]\n", z_pos_mea);
           fprintf(fh, "# %0.2lf [measurement location X - full scale [m]]\n", (x_pos_mea/1000)*model_scale);
           fprintf(fh, "# %0.2lf [measurement location Y - full scale [m]]\n", (y_pos_mea/1000)*model_scale);
           fprintf(fh, "# %0.2lf [measurement location Z - full scale [m]]\n", (z_pos_mea/1000)*model_scale);
           fprintf(fh, "# # [measurement location utm Easting [m]]\n");//, 634606 - ((((x_pos_mea/1000)*model_scale)*sin((180-windd)*(3.14159/180))) + (((y_pos_mea/1000)*model_scale)*cos((180-windd)*(3.14159/180)))));
           fprintf(fh, "# # [measurement location utm Northing [m]]\n");//, 3926044 + (((x_pos_mea/1000)*model_scale)*cos((180-windd)*(3.14159/180))) - (((y_pos_mea/1000)*model_scale)*sin((180-windd)*(3.14159/180))));
           fprintf(fh, "# %5.2lf [1E-6 * confidence intervall [-]]\n", reproducibility);
           fprintf(fh, "# \n# \n# \n# \n# \n# \n# \n# \n");

           fprintf(fh, "# \n");
           fprintf(fh, "# ********** END OF HEADER **********\n");


           fprintf(fh, "VARIABLES = \"t<sup>*</sup>[-]\" \"1E-6<math>W</math>c<sup>*</sup>[-]\"\n");

           blocknumber = 0;//1;
           //blocknumber_max = (int)((Releaseindex)/blcksz)-1;

                
           fprintf(fh, "ZONE T=\"plume-release\"\n");

           do {
               if (Releasedata_ave[Releasenumber][1][blocknumber] >= time_needle) {
                   fprintf(fh, "%5.2lf   %5.2lf\n", ((Releasedata_ave[Releasenumber][1][blocknumber] - time_needle)*U_ref)/(ref_length),
                                                    (Releasedata_ave[Releasenumber][9][blocknumber]*U_ref*pow(ref_length,2)/(volume_flow))/1000000.);
               }
               //printf("blocknumber: %i\n", blocknumber);
               blocknumber++;
           } while (blocknumber <= blocknumber_max);
                    
               
           fclose(fh);
           
    
    //printf("Releasenumber: %i\n", Releasenumber);
    //printf("3WINDD: %lf\n", windd);
    //printf("3WINDD: %i\n", (int) (windd*10));

    /****************************************************************************/
}








