// cc_analysis_puff_functions
// created: 02-10-2011
// author:  RF
// last modification: 02-10-2011







void extract_releases_puff() {
    
    /************* EXTRACTION OF RELEASES ****************/

    //printf(" ... extracting puff releases!\n");
    detec_index   = 0;
    index         = 0;
    Releasenumber = 0;
    Releaseindex  = 0;
    tt_int[index] = 0.;//-1. * time_needle;

    do {

        if(trig[index] >= 2.5 && detec_index == 0) {
            Releaselength[Releasenumber] = Releaseindex;
            Releasenumber++;
            //printf("Releasenumber: %i    detec_index: %i   sample_freq: %5.2lf   d_samp: %5.2lf\n", Releasenumber, detec_index, sample_freq, down_sampling);

            Releaseindex = 0;
            detec_index  = (int)(t_open * sample_freq/down_sampling);
            
            tt_int[index] = 0.;//-1. * time_needle;
        }

     
        if(detec_index > 0) {
            detec_index--;
        }
        //printf("        %i\n", index);
        //printf("                %i\n", detec_index);
     
        Releasedata_raw[Releasenumber][1][Releaseindex] = tt[index];        
        Releasedata_raw[Releasenumber][2][Releaseindex] = tt_int[index];        
        Releasedata_raw[Releasenumber][3][Releaseindex] = upt[index];        
        Releasedata_raw[Releasenumber][4][Releaseindex] = cb[index];        
        Releasedata_raw[Releasenumber][5][Releaseindex] = c[index];        
        Releasedata_raw[Releasenumber][6][Releaseindex] = cef[index];
        Releasedata_raw[Releasenumber][7][Releaseindex] = qsource[index];        
        Releasedata_raw[Releasenumber][8][Releaseindex] = trig[index];

        Releaseindex++;
        index++;
        tt_int[index] = tt_int[index-1] + (1./(sample_freq/down_sampling));

    } while (index < count);

    Releasenumber_Max = Releasenumber-1;
    

    if(Releasenumber_Max != 1) {
        printf(" %i releases extracted!\n\n", Releasenumber_Max);
    }
    if(Releasenumber_Max == 1) {
        printf(" %i release extracted!\n\n", Releasenumber_Max);
    }

    /********************************************************/
}












void detect_rel_dur_puff() {
    
    /**************** DETECTION OF RELEASE-DURATION *********/

    Releasenumber = 1;
    index         = 0;
    sum_trig_time = 0.;
    trig_time_max = 0.;
    trig_time_min = 100000000.;

    do {

        trig_time_index[Releasenumber] = 0;
        Releaseindex             = 1;
        do {
            if(trig[index] >= 2.5) {
                trig_time_index[Releasenumber]++;
            }
            Releaseindex++;
            index++;
        } while (Releaseindex <= Releaselength[Releasenumber]);

        if(trig_time_index[Releasenumber] * (down_sampling/sample_freq) < trig_time_min) {
            trig_time_min = trig_time_index[Releasenumber] * (down_sampling/sample_freq);
        }
        if(trig_time_index[Releasenumber] * (down_sampling/sample_freq) > trig_time_max) {
            trig_time_max = trig_time_index[Releasenumber] * (down_sampling/sample_freq);
        }

        trig_time[Releasenumber] = trig_time_index[Releasenumber] * (down_sampling/sample_freq);
        sum_trig_time            = sum_trig_time + trig_time[Releasenumber];

        //printf("trig_time[%i] = %lf\n", Releasenumber, trig_time[Releasenumber]);
        
        Releasenumber++;
        index++;
    } while (Releasenumber <= Releasenumber_Max);

    
    trig_time_mean = sum_trig_time/(Releasenumber_Max);
    

    printf(" duration of release:\n min:   %5.2lf s\n max:   %5.2lf s\n mean:  %5.2lf s\n\n",
            trig_time_min, trig_time_max, trig_time_mean);
         
    /******************************************************/
}











void correct_sig_offset_puff() {
    
    /*********************** SIGNAL-OFFSET CORRECTION *******************/

    Releasenumber  = 1;
    sum_cef_offset = 0.0;

    do {
        Releaseindex              = 0;
        cef_offset[Releasenumber] = 0.0;
        sum_cef                   = 0.0;
     
        do {
            sum_cef = sum_cef + Releasedata_raw[Releasenumber][6][Releaseindex];
            //printf("    Release: %i    index: %i   ceff: %lf\n", Releasenumber, Releaseindex, Releasedata_raw[Releasenumber][6][Releaseindex]);
            Releaseindex++;
        } while(Releaseindex * (1./(sample_freq/down_sampling)) <= offset_time);
        cef_offset[Releasenumber] = sum_cef/Releaseindex;
        sum_cef_offset = sum_cef_offset + cef_offset[Releasenumber];
        Releasenumber++;
    } while(Releasenumber <= Releasenumber_Max);
    mean_cef_offset = sum_cef_offset/(Releasenumber-1);

    printf(" offset: %5.1lf ppmv\n\n", mean_cef_offset);

    Releasenumber = 1;
    do {
        Releaseindex = 0;
        do {
            Releasedata_raw[Releasenumber][9][Releaseindex] = Releasedata_raw[Releasenumber][6][Releaseindex] - mean_cef_offset;
            Releaseindex++;
        } while(Releaseindex < Releaselength[Releasenumber]);
        Releasenumber++;
    } while(Releasenumber <= Releasenumber_Max);

    /*******************************************************************/
}









void blck_ave_puff() {    
    
    /******* BLOCK-AVERAGING ************************/

    //printf(" ... block-averaging!\n");
    Releasenumber = 1;
    do {
        Releaseindex = 0;
        Blocknumber  = 0;
        Blocknumber_Max[Releasenumber] = (int) ((Releaselength[Releasenumber])/blcksz) - 1;

        do {
            block_count = 1;
            sum_tt      = 0.0;
            sum_tt_int  = 0.0;
            sum_upt     = 0.0;
            sum_cb      = 0.0;
            sum_c       = 0.0;
            sum_cef     = 0.0;
            sum_qsource = 0.0;
            sum_trig    = 0.0;
            sum_ccorr   = 0.0;
         
            do {
                sum_tt      = sum_tt      + Releasedata_raw[Releasenumber][1][Releaseindex];
                sum_tt_int  = sum_tt_int  + Releasedata_raw[Releasenumber][2][Releaseindex];
                sum_upt     = sum_upt     + Releasedata_raw[Releasenumber][3][Releaseindex];
                sum_cb      = sum_cb      + Releasedata_raw[Releasenumber][4][Releaseindex];
                sum_c       = sum_c       + Releasedata_raw[Releasenumber][5][Releaseindex];
                sum_cef     = sum_cef     + Releasedata_raw[Releasenumber][6][Releaseindex];
                sum_qsource = sum_qsource + Releasedata_raw[Releasenumber][7][Releaseindex];
                sum_trig    = sum_trig    + Releasedata_raw[Releasenumber][8][Releaseindex];
                sum_ccorr   = sum_ccorr   + Releasedata_raw[Releasenumber][9][Releaseindex];

                //printf("sum_tt: %lf  sum_tt_int: %lf\n", sum_tt, sum_tt_int);
                
                block_count++;
                Releaseindex++;
            } while (block_count <= blcksz);

            Releasedata_ave[Releasenumber][1][Blocknumber] = sum_tt/blcksz;                
            Releasedata_ave[Releasenumber][2][Blocknumber] = sum_tt_int/blcksz;                
            Releasedata_ave[Releasenumber][3][Blocknumber] = sum_upt/blcksz;                
            Releasedata_ave[Releasenumber][4][Blocknumber] = sum_cb/blcksz;                
            Releasedata_ave[Releasenumber][5][Blocknumber] = sum_c/blcksz;                
            Releasedata_ave[Releasenumber][6][Blocknumber] = sum_cef/blcksz;
            Releasedata_ave[Releasenumber][7][Blocknumber] = sum_qsource/blcksz;                
            Releasedata_ave[Releasenumber][8][Blocknumber] = sum_trig/blcksz;
            Releasedata_ave[Releasenumber][9][Blocknumber] = sum_ccorr/blcksz;

            //printf("ave_tt: %lf  ave_tt_int: %lf\n\n", Releasedata_ave[Releasenumber][1][Blocknumber], Releasedata_ave[Releasenumber][2][Blocknumber]);

            Blocknumber++;
        } while (Blocknumber <= Blocknumber_Max[Releasenumber]);

        Releasenumber++;
    } while (Releasenumber <= Releasenumber_Max);
    printf(" releases block-averaged!\n\n");

    //printf("TEST1: %lf %lf\n", Releasedata_ave[5][6][20], Releasedata_ave[5][9][20]);

 
    Releasenumber = 1;
    do {
        Blocknumber  = 0;
        sum_cc[Releasenumber][Blocknumber] = 0.0;
        do {
            if(Releasedata_ave[Releasenumber][2][Blocknumber] < time_needle) {
                sum_cc[Releasenumber][Blocknumber] = 0.0;
            }
            if(Releasedata_ave[Releasenumber][2][Blocknumber] >= time_needle) {
                if(Blocknumber == 0) {  
                    sum_cc[Releasenumber][Blocknumber] = sum_cc[Releasenumber][Blocknumber] + Releasedata_ave[Releasenumber][9][Blocknumber];
                }
                if(Blocknumber > 0) {
                    sum_cc[Releasenumber][Blocknumber] = sum_cc[Releasenumber][Blocknumber-1] + Releasedata_ave[Releasenumber][9][Blocknumber];
                }
            }
            Blocknumber++;
        } while (Blocknumber <= Blocknumber_Max[Releasenumber]);
        Releasenumber++;
    } while (Releasenumber <= Releasenumber_Max);

   /****************************************************************************/
}











void reject_signals() {
    
    /*********************** REJECTING NOT DETECTED PUFFS ****************/

    //printf(" ... detecting puffs!\n");

    Releasenumber     = 1;
    dt                = (1./(sample_freq/down_sampling)) * blcksz;
    puff_detec_number = 0;
    do {
        dosage_0          = 0.0;
        dosage[Releasenumber] = 0.0;
        puffmarker[Releasenumber] = 0;
        quality_flag[Releasenumber] = 1;
        Blocknumber = 0;
        do {

            dosage_0 = dosage_0 + Releasedata_ave[Releasenumber][9][Blocknumber];

            //printf("ccorr: %lf\n", Releasedata_ave[Releasenumber][9][Blocknumber]);

            Blocknumber++;
        } while (Blocknumber <= Blocknumber_Max[Releasenumber]);

        dosage[Releasenumber] = dt * dosage_0;

        //printf("dosage[%i]:  %lf * %lf = %lf\n", Releasenumber, dt, dosage_0, dosage[Releasenumber]);

        if (dosage[Releasenumber] >= threshold) {
                puffmarker[Releasenumber] = 1;
                quality_flag[Releasenumber] = 0;
        }

        if (puffmarker[Releasenumber] == 1) {
            puff_detec_number++;
        }    

        //printf("dosage[%i]: %5.2lf\n", Releasenumber, dosage[Releasenumber]);
        //printf("Releasenumber: %i    Puffmarker: %i\n", Releasenumber, puffmarker[Releasenumber]);
     
        Releasenumber++;
    } while (Releasenumber <= Releasenumber_Max);      
        
    printf(" %i puffs detected (out of %i releases)!   (threshold: %5.1lf ppmvs)\n", puff_detec_number, Releasenumber_Max, threshold);
                
 
    //printf("TEST2: %lf %lf\n", Releasedata_ave[5][6][20], Releasedata_ave[5][9][20]);
 
    /**************************************************************************/
}











void puff_output_ceff_check() {

    mkdir("ceff_check");

    sprintf(output_puff01, "ceff_check\\%s", input_file);
 
    fh = fopen(output_puff01, "w");

    fprintf(fh, "VARIABLES = \"T[s]\" \"C[ppmv]\" \"Cb[ppmv]\" \"Ceff[ppmv]\"\n");

    for(count = 0; count < samples; count++) {
        fprintf(fh, "%5.3lf      %5.1lf    %5.1lf    %5.1lf\n", tt[count], c[count], cb[count], cef[count]);
    }
    
    close(fh);
}







void puff_output_coffs_check() {

    mkdir("coffs_check");

    sprintf(output_puff02, "coffs_check\\%s", input_file);
 
    fh = fopen(output_puff02, "w");

    fprintf(fh, "VARIABLES = \"T [s]\" \"T<sub>int</sub> [s]\" \"C [ppmv]\" \"C<sub>b</sub> [ppmv]\" \"C<sub>eff</sub> [ppmv]\" \"Trigger [V]\"\n");


    Releasenumber = 1;
    do {
        Releaseindex = 0;
               
                
        fprintf(fh, "ZONE T=\"puff-release %i\"\n", Releasenumber-1);

        do {
            fprintf(fh, "%5.3lf  %5.3lf      %5.1lf    %5.1lf    %5.1lf    %5.2lf\n", Releasedata_raw[Releasenumber][1][Releaseindex], Releasedata_raw[Releasenumber][2][Releaseindex],
                                                                              Releasedata_raw[Releasenumber][4][Releaseindex], Releasedata_raw[Releasenumber][5][Releaseindex],
                                                                              Releasedata_raw[Releasenumber][6][Releaseindex], Releasedata_raw[Releasenumber][8][Releaseindex]);
            
                   
        
            Releaseindex++;
        } while (Releaseindex < Releaselength[Releasenumber]);
                    
        Releasenumber++;
    } while (Releasenumber <= Releasenumber_Max);


    close(fh);
}







void puff_output_ccorr_check() {

    mkdir("ccorr_check");

    sprintf(output_puff02, "ccorr_check\\%s", input_file);
 
    fh = fopen(output_puff02, "w");

    fprintf(fh, "VARIABLES = \"T [s]\" \"T<sub>int</sub> [s]\" \"C<sub>eff</sub> [ppmv]\" \"C<sub>corr</sub> [ppmv]\" \"Trigger [V]\"\n");


    Releasenumber = 1;
    do {
        Releaseindex = 0;
               
                
        fprintf(fh, "ZONE T=\"puff-release %i\"\n", Releasenumber-1);

        do {
            fprintf(fh, "%5.3lf  %5.3lf      %5.1lf    %5.1lf    %5.2lf\n", Releasedata_raw[Releasenumber][1][Releaseindex], Releasedata_raw[Releasenumber][2][Releaseindex],
                                                                          Releasedata_raw[Releasenumber][6][Releaseindex], Releasedata_raw[Releasenumber][9][Releaseindex],
                                                                          Releasedata_raw[Releasenumber][8][Releaseindex]);
            
                   
        
            Releaseindex++;
        } while (Releaseindex < Releaselength[Releasenumber]);
                    
        Releasenumber++;
    } while (Releasenumber <= Releasenumber_Max);


    close(fh);
}






void puff_output_ave_check() {

    mkdir("ave_check");

    sprintf(output_puff02, "ave_check\\%s", input_file);
 
    fh = fopen(output_puff02, "w");

    fprintf(fh, "VARIABLES = \"T [s]\" \"T<sub>int</sub> [s]\" \"C<sub>eff</sub> [ppmv]\" \"C<sub>corr</sub> [ppmv]\" \"Trigger [V]\"\n");


    Releasenumber = 1;
    do {
        Blocknumber = 0;

        Blocknumber_Max[Releasenumber] = (int)((Releaselength[Releasenumber])/blcksz)-1;       
                
        fprintf(fh, "ZONE T=\"puff-release %i\"\n", Releasenumber-1);

        do {
            fprintf(fh, "%5.4lf %5.4lf     %5.1lf    %5.1lf    %5.2lf\n", Releasedata_ave[Releasenumber][1][Blocknumber], Releasedata_ave[Releasenumber][2][Blocknumber],
                                                                          Releasedata_ave[Releasenumber][6][Blocknumber], Releasedata_ave[Releasenumber][9][Blocknumber],
                                                                          Releasedata_ave[Releasenumber][8][Blocknumber]);
            
                   
        
            Blocknumber++;
        } while (Blocknumber <= Blocknumber_Max[Releasenumber]);
                    
        Releasenumber++;
    } while (Releasenumber <= Releasenumber_Max);


    close(fh);
}







void puff_output_sort_check() {

    mkdir("sort_check");

    sprintf(output_puff02, "sort_check\\%s", input_file);
 
    fh = fopen(output_puff02, "w");

    fprintf(fh, "VARIABLES = \"T [s]\" \"T<sub>int</sub> [s]\" \"C<sub>eff</sub> [ppmv]\" \"C<sub>corr</sub> [ppmv]\" \"Trigger [V]\" \"U<sub>P</sub> [m/s]\"\n");


    Releasenumber = 1;
    do {
        Blocknumber = 0;

        Blocknumber_Max[Releasenumber] = (int)((Releaselength[Releasenumber])/blcksz)-1;       
                
        fprintf(fh, "ZONE T=\"puff-release %i\"\n", Releasenumber-1);

        do {
            fprintf(fh, "%5.4lf %5.4lf     %5.1lf    %5.1lf    %5.2lf         %5.2lf\n", Releasedata_ave[Releasenumber][1][Blocknumber], Releasedata_ave[Releasenumber][2][Blocknumber],
                                                                                         Releasedata_ave[Releasenumber][6][Blocknumber], Releasedata_ave[Releasenumber][9][Blocknumber],
                                                                                         Releasedata_ave[Releasenumber][8][Blocknumber], Releasedata_ave[Releasenumber][3][Blocknumber]);
            
                   
        
            Blocknumber++;
        } while (Blocknumber <= Blocknumber_Max[Releasenumber]);
                    
        Releasenumber++;
    } while (Releasenumber <= Releasenumber_Max);


    close(fh);
}








void puff_output_vol_flow_check() {
    
    mkdir("vol_flow_check");

    sprintf(output_puff02, "vol_flow_check\\%s", input_file);
 
    fh = fopen(output_puff02, "w");

    fprintf(fh, "VARIABLES = \"T<sub>int</sub> [s]\" \"q<sub>S</sub> [V]\" \"q<sub>V</sub> [m<sup>3</sup>/s]\"\n");


    Releasenumber = 1;
    do {
        Blocknumber = 0;

        Blocknumber_Max[Releasenumber] = (int)((Releaselength[Releasenumber])/blcksz)-1;       
                
        fprintf(fh, "ZONE T=\"puff-release %i\"\n", Releasenumber-1);

        do {
            fprintf(fh, "%5.3lf    %5.2lf    %5.2e\n", Releasedata_ave[Releasenumber][2][Blocknumber], Releasedata_ave[Releasenumber][7][Blocknumber],
                                                      gcf * (0.001/3600) * ((Releasedata_ave[Releasenumber][7][Blocknumber] * coefficient_a) + coefficient_b) * ((101325. * (273.15 + temperature))/(273.15 * (100. * pressure))));
            
                   
        
            Blocknumber++;
        } while (Blocknumber <= Blocknumber_Max[Releasenumber]);
                    
        Releasenumber++;
    } while (Releasenumber <= Releasenumber_Max);


    close(fh);
}









void data_output_puff() {
    
    /************************ DATA-OUTPUT *********************************/


    volume_flow = gcf * (0.001/3600) * ((Qsource * coefficient_a) + coefficient_b) * ((101325. * (273.15 + temperature))/(273.15 * (100. * pressure)));
    released_volume = volume_flow * trig_time_mean;
    //printf("\nvolume_flow: %10.9lf\n", volume_flow);
    //printf("released volume: %10.9lf\n", released_volume);
    //printf("release duration: %10.9lf\n", trig_time_mean);
    //printf("Qsource      : %lf\n", Qsource);
    //printf("gcf          : %lf\n", gcf);
    //printf("coefficient_a: %lf\n", coefficient_a);
    //printf("coefficient_b: %lf\n", coefficient_b);
    //printf("temperature  : %lf\n", temperature);
    //printf("pressure     : %lf\n", pressure);
    //printf("fac 1: %10.8lf\n", gcf * (0.001/3600));
    //printf("fac 2: %lf\n", ((Qsource * coefficient_a) + coefficient_b));
    //printf("fac 3: %lf\n", ((101325. * (273.15 + temperature))/(273.15 * (100. * pressure))));

  

    mkdir("TS");

    if (meas_point <= 999 && meas_point > 99) {
        strcpy(point_string, "");
    }
    if (meas_point <= 99 && meas_point > 9) {
        strcpy(point_string, "0");
    }
    if (meas_point <= 9 && meas_point >= 0) {
        strcpy(point_string, "00");
    }

 

    if ((int)((z_pos_mea/10)*model_scale) > 9999 && (int)((z_pos_mea/10)*model_scale) <= 99999) {
        strcpy(z_string, "");
    }
    if ((int)((z_pos_mea/10)*model_scale) > 999 && (int)((z_pos_mea/10)*model_scale) <= 9999) {
        strcpy(z_string, "0");
    }
    if ((int)((z_pos_mea/10)*model_scale) > 99 && (int)((z_pos_mea/10)*model_scale) <= 999) {
        strcpy(z_string, "00");
    }
    if ((int)((z_pos_mea/10)*model_scale) > 9 && (int)((z_pos_mea/10)*model_scale) <= 99) {
        strcpy(z_string, "000");
    }
    if ((int)((z_pos_mea/10)*model_scale) >= 0 && (int)((z_pos_mea/10)*model_scale) <= 9) {
        strcpy(z_string, "0000");
    }

 

    //printf("1WINDD: %lf\n", windd);
    //printf("1WINDD: %i\n", (int) (windd*10));
    if ((int)(windd*10) > 999 && (int)(windd*10) <= 9999) {
        strcpy(windd_string, "");
    }
    if ((int)(windd*10) > 99 && (int)(windd*10) <= 999) {
        strcpy(windd_string, "0");
    }
    if ((int)(windd*10) > 9 && (int)(windd*10) <= 99) {
        strcpy(windd_string, "00");
    }
    if ((int)(windd*10) >= 0 && (int)(windd*10) <= 9) {
        strcpy(windd_string, "000");
    }
    //printf("2WINDD: %lf\n", windd);
    //printf("2WINDD: %i\n", (int) (windd*10));

    if (reproducibility == 999.99) {
        reproducibility = reproducibility;
    }
    if (reproducibility != 999.99) {
        reproducibility = (reproducibility*pow(ref_length,3)/released_volume)/1000000.;
    }
    
    //printf("%s\n", str_source);
    sprintf(output_TIMESERIES, "TS\\%s_WD%s%i_P%s%i_Z%s%i_%s_nd.dts", str_source, windd_string, (int)(windd*10), point_string, meas_point, z_string, (int)((z_pos_mea/10)*model_scale), ts_number);
 
    //printf("TEST3: %lf %lf\n", Releasedata_ave[5][6][20], Releasedata_ave[5][9][20]);
 
    fh = fopen(output_TIMESERIES, "w");

 

           fprintf(fh, "# EWTL post-processed puff dispersion measurement\n");
           fprintf(fh, "# \n");
           fprintf(fh, "# ********** DATA DESCRIPTION **********\n");
           fprintf(fh, "# \n# \n# \n# \n# \n");
           fprintf(fh, "# ********** GENERAL INFORMATION **********\n");
           fprintf(fh, "# %s [main project name]\n", str_maincamp);
           fprintf(fh, "# %s [sub project name]\n", str_subcamp);
           fprintf(fh, "# %s [wind tunnel facility]\n", str_wt);
           fprintf(fh, "# 1:%i [model scale]\n", model_scale);
           fprintf(fh, "# %0.1lf [zref - model scale [mm]]\n", ref_height*1000.);
           fprintf(fh, "# %0.2lf [zref - full scale [m]]\n", ref_height*model_scale);        
           fprintf(fh, "# %0.2lf [Uref - model [m/s]]\n", U_ref);
           fprintf(fh, "# %0.2lf [wind direction []]\n", windd);
           fprintf(fh, "# %5.4lf [Lref - model scale [mm]]\n", ref_length*1000.);
           fprintf(fh, "# %5.1lf [Lref - full scale [m]]\n", ref_length*model_scale);
           //fprintf(fh, "14 [utm zone]\n");
           //fprintf(fh, "PLEASE NOTE: The X-axis of the wind tunnel reference system is always aligned with the corresponding mean wind direction of the approach flow! see readme.txt \n");
           fprintf(fh, "# \n# PLEASE NOTE: A threshold is applied to the dosage of each puff signal!\n");
           fprintf(fh, "#              Signals, which dosage did not reach this threshold are labeled\n");
           fprintf(fh, "#              with the quality-flag \"1\" and might not be adequate for the analysis\n");
           fprintf(fh, "#              of puff-dispersion!\n");
            
           fprintf(fh, "# \n# \n# \n# \n# \n");

           fprintf(fh, "# ********** FLOW MEASUREMENTS **********\n");
           fprintf(fh, "# # [measurement type]\n");
           fprintf(fh, "# # [number of columns]\n");
           fprintf(fh, "# # [labels]\n");
           fprintf(fh, "# # [measured components]\n");
           fprintf(fh, "# # [measurement location X - model scale [mm]]\n");  
           fprintf(fh, "# # [measurement location Y - model scale [mm]]\n");  
           fprintf(fh, "# # [measurement location Z - model scale [mm]]\n");  
           fprintf(fh, "# # [measurement location X - full scale [m]]\n");  
           fprintf(fh, "# # [measurement location Y - full scale [m]]\n");  
           fprintf(fh, "# # [measurement location Z - full scale [m]]\n");
           fprintf(fh, "# # [measurement location utm Easting [m]]\n");
           fprintf(fh, "# # [measurement location utm Northing [m]]\n");
           fprintf(fh, "# # [confidence intervall {U,V,W}/Uref[-]]\n");
        
           fprintf(fh, "# \n# \n# \n# \n# \n# \n# \n# \n# \n# \n");

           fprintf(fh, "# ********** CONCENTRATION MEASUREMENTS **********\n");
           fprintf(fh, "# %s puff [measurement type]\n", str_meastype);
           fprintf(fh, "# 3 [number of columns]\n");
           fprintf(fh, "# \"T*\" \"C*\" \"quality-flag\" [labels]\n");
           fprintf(fh, "# %s [released gas]\n", str_tracer);
           fprintf(fh, "# %0.2lf [source strength [l/h]]\n", volume_flow/(0.001/3600));
           fprintf(fh, "# %0.2lf [release duration [s]]\n", trig_time_mean);
           fprintf(fh, "# %i [number of released puffs]\n", Releasenumber_Max);
           fprintf(fh, "# %i [number of detected puffs, which dosage exceeds the dosage threshold]\n", puff_detec_number);
           fprintf(fh, "# %5.2lf [dosage threshold - model scale [ppmvs]]\n", threshold);
           fprintf(fh, "# %0.2lf [source location X - model scale [mm]]\n", x_pos_rel);
           fprintf(fh, "# %0.2lf [source location Y - model scale [mm]]\n", y_pos_rel);
           fprintf(fh, "# %0.2lf [source location Z - model scale [mm]]\n", z_pos_rel);
           fprintf(fh, "# %0.2lf [source location X - full scale [m]]\n", (x_pos_rel/1000)*model_scale);
           fprintf(fh, "# %0.2lf [source location Y - full scale [m]]\n", (y_pos_rel/1000)*model_scale);
           fprintf(fh, "# %0.2lf [source location Z - full scale [m]]\n", (z_pos_rel/1000)*model_scale);
           fprintf(fh, "# # [source location utm Easting [m]]\n");//, 634606 - ((((x_pos_rel/1000)*model_scale)*sin((180-windd)*(3.14159/180))) + (((y_pos_rel/1000)*model_scale)*cos((180-windd)*(3.14159/180)))));
           fprintf(fh, "# # [source location utm Northing [m]]\n");//, 3926044 + (((x_pos_rel/1000)*model_scale)*cos((180-windd)*(3.14159/180))) - (((y_pos_rel/1000)*model_scale)*sin((180-windd)*(3.14159/180))));
           fprintf(fh, "# %0.2lf [measurement location X - model scale [mm]]\n", x_pos_mea);
           fprintf(fh, "# %0.2lf [measurement location Y - model scale [mm]]\n", y_pos_mea);
           fprintf(fh, "# %0.2lf [measurement location Z - model scale [mm]]\n", z_pos_mea);
           fprintf(fh, "# %0.2lf [measurement location X - full scale [m]]\n", (x_pos_mea/1000)*model_scale);
           fprintf(fh, "# %0.2lf [measurement location Y - full scale [m]]\n", (y_pos_mea/1000)*model_scale);
           fprintf(fh, "# %0.2lf [measurement location Z - full scale [m]]\n", (z_pos_mea/1000)*model_scale);
           fprintf(fh, "# # [measurement location utm Easting [m]]\n");//, 634606 - ((((x_pos_mea/1000)*model_scale)*sin((180-windd)*(3.14159/180))) + (((y_pos_mea/1000)*model_scale)*cos((180-windd)*(3.14159/180)))));
           fprintf(fh, "# # [measurement location utm Northing [m]]\n");//, 3926044 + (((x_pos_mea/1000)*model_scale)*cos((180-windd)*(3.14159/180))) - (((y_pos_mea/1000)*model_scale)*sin((180-windd)*(3.14159/180))));
           fprintf(fh, "# %5.2lf [1E-6 * confidence intervall [-]]\n", reproducibility);
           fprintf(fh, "# \n# \n# \n# \n# \n# \n# \n# \n");

           fprintf(fh, "# \n");
           fprintf(fh, "# ********** END OF HEADER **********\n");


           fprintf(fh, "VARIABLES = \"T<sup>*</sup>[-]\" \"1E-6<math>W</math>C<sup>*</sup>[-]\" \"quality-flag[-]\"\n");

           Releasenumber = 1;
           do {
               //Releaseindex = 1;
               Blocknumber = 0;//1;
               Blocknumber_Max[Releasenumber] = (int)((Releaselength[Releasenumber])/blcksz)-1;

                
               fprintf(fh, "ZONE T=\"puff-release %i  quality-flag: %i\"\n", Releasenumber-1, quality_flag[Releasenumber]);

               do {
                    if (Releasedata_ave[Releasenumber][2][Blocknumber] >= time_needle) {
                         fprintf(fh, "%5.2lf   %5.2lf    %i\n", ((Releasedata_ave[Releasenumber][2][Blocknumber] - time_needle)*U_ref)/(ref_length),
                                                          (Releasedata_ave[Releasenumber][9][Blocknumber]*pow(ref_length,3)/released_volume)/1000000.,
                                                          quality_flag[Releasenumber]);
                    }   
                    Blocknumber++;
               } while (Blocknumber <= Blocknumber_Max[Releasenumber]);
                    
               Releasenumber++;
           } while (Releasenumber <= Releasenumber_Max);

           fclose(fh);
    

    //printf("3WINDD: %lf\n", windd);
    //printf("3WINDD: %i\n", (int) (windd*10));

    /****************************************************************************/
}













