// LDA_ANALYSIS_2.1
// created: 10-29-2009
// author:  RF
// last modification: 10-29-2009 

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <string.h>
#include <fcntl.h>
#include <io.h>
#include <share.h>
#include <math.h>

//LabWindows
#include "C:\cvi401\include\cvirte.h"
#include "C:\cvi401\include\analysis.h"

// WT_A include files used
#include "FL_ANALYSIS_defines.h"
#include "FL_ANALYSIS_globalvar.h"
#include "FL_ANALYSIS_func2.h"
#include "FL_ANALYSIS_inputs.h"
#include "FL_ANALYSIS_outputs.h"
#include "FL_ANALYSIS_func1.h"
#include "FL_ANALYSIS_modules.h"


void main(int argc, char *argv[])
{
    char  string1[MEAS_CODE_LENGTH], string2[MEAS_CODE_LENGTH];
    int   i, j, k;
    
    if(argc > 26) {//9) {
        printf("\n\n\a\a\a wrong program call!\n");
        user_instruction1();
        printf("\n program will be aborted!\n");
        while (!kbhit());
        exit(0);
    }



    /************ standard values for parameters **************************/

    lda_ts_number         = 1;
    lda_ts_startnumber    = 1;
    model_scale           = 1;
    ref_height            = 1.0;
    lda_scale_factor      = 1.0;
    char_length           = 1.0;
    rough_el_height       = 0.0;
    classnumber_speed     = 0;
    confidence_interval   = 95.0;
    classnumber_direction = 360;
    fft_data              = 16384;
    reproducibility_comp1 = 999.999;
    reproducibility_comp2 = 999.999;
    prandtl_layer_min     = 100.;
    prandtl_layer_max     = 100.;
    output_statistics     = 1;
    output_timeseries     = 0;
    output_spectrum       = 0;
    output_fluctuations   = 0;
    output_histograms     = 0;
                               /*********** "secret" parameters ***********/

                               output_ts_resamp       = 0;
                               output_autocorrelation = 0;
                               output_outlier_subst   = 0;
                               raw_filename_output    = 0;
                               
    /**********************************************************************/

    
        
    if(argc > 1) {
        string2[0] = '\0';
        for (i=1; i<argc; i++) {
            strncpy(string1, argv[i], CODESIZE);
            k = 0;
            for (j = CODESIZE; j <= strlen(argv[i]); j++) {
                string2[k] = argv[i][j];
                k++;
            }
            if(!strcmp(string1, "MEAS_C:")||!strcmp(string1, "meas_c:"))
               strcpy(meas_code, string2);
            if(!strcmp(string1, "TS_NBR:")||!strcmp(string1, "ts_nbr:"))
               lda_ts_number = atoi(string2);
            if(!strcmp(string1, "TS_STN:")||!strcmp(string1, "ts_stn:"))
               lda_ts_startnumber = atoi(string2);
            if(!strcmp(string1, "ML_SCL:")||!strcmp(string1, "ml_scl:"))
               model_scale = atoi(string2);
            if(!strcmp(string1, "REF_HT:")||!strcmp(string1, "ref_ht:"))
               ref_height = atof(string2);
            if(!strcmp(string1, "SC_FAC:")||!strcmp(string1, "sc_fac:"))
               lda_scale_factor = atof(string2);
            if(!strcmp(string1, "L_CHAR:")||!strcmp(string1, "l_char:"))
               char_length = atof(string2);
            if(!strcmp(string1, "REL_HT:")||!strcmp(string1, "rel_ht:"))
               rough_el_height = atof(string2);   
            if(!strcmp(string1, "CN_SPD:")||!strcmp(string1, "cn_spd:"))
               classnumber_speed = atoi(string2);
            if(!strcmp(string1, "CONF_I:")||!strcmp(string1, "conf_i:"))
               confidence_interval = atof(string2);
            if(!strcmp(string1, "CN_DIR:")||!strcmp(string1, "cn_dir:"))
               classnumber_direction = atoi(string2);
            if(!strcmp(string1, "FFT_NN:")||!strcmp(string1, "fft_nn:"))   
               fft_data = atoi(string2);
            if(!strcmp(string1, "REPRO1:")||!strcmp(string1, "repro1:"))   
               reproducibility_comp1 = atof(string2);
            if(!strcmp(string1, "REPRO2:")||!strcmp(string1, "repro2:"))   
               reproducibility_comp2 = atof(string2);   
            if(!strcmp(string1, "PL_MIN:")||!strcmp(string1, "pl_min:"))
               prandtl_layer_min = atof(string2);
            if(!strcmp(string1, "PL_MAX:")||!strcmp(string1, "pl_max:"))
               prandtl_layer_max = atof(string2);   
            if(!strcmp(string1, "O_STAT:")||!strcmp(string1, "o_stat:"))
               output_statistics = atoi(string2);
            if(!strcmp(string1, "O_TIMS:")||!strcmp(string1, "o_tims:"))
               output_timeseries = atoi(string2);
            if(!strcmp(string1, "O_SPEC:")||!strcmp(string1, "o_spec:"))
               output_spectrum = atoi(string2);
            if(!strcmp(string1, "O_FLUC:")||!strcmp(string1, "o_fluc:"))
               output_fluctuations = atoi(string2);
            if(!strcmp(string1, "O_HIST:")||!strcmp(string1, "o_hist:"))
               output_histograms = atoi(string2);
            if(!strcmp(string1, "O_DEFT:")||!strcmp(string1, "o_deft:"))
               output_deflection_time = atoi(string2);   
               
            if(!strcmp(string1, "O_TSRS:")||!strcmp(string1, "o_tsrs:"))
               output_ts_resamp = atoi(string2);
            if(!strcmp(string1, "O_AUTO:")||!strcmp(string1, "o_auto:"))
               output_autocorrelation = atoi(string2);
            if(!strcmp(string1, "O_OSUB:")||!strcmp(string1, "o_osub:"))
               output_outlier_subst = atoi(string2);
            if(!strcmp(string1, "RFN_OP:")||!strcmp(string1, "rfn_op:"))
               raw_filename_output = atoi(string2);          

            string2[0] = '\0'; 
        }
    }


    if(confidence_interval != 90.0 && confidence_interval != 95.0 && confidence_interval != 99.0) {
        printf("\n\n\a\a\a confidence interval must be set to:\n 90, 95 or 99%\n");
        printf("\n program will be aborted!\n");
        while (!kbhit());
        exit(0);
    }


    if(output_statistics == 1) { 
        mkdir("STAT");
    }
    
    if(output_timeseries == 1) {
        mkdir("TS");
    }
    if(output_spectrum == 1) {
        mkdir("SPEC");
    }
    if(output_fluctuations == 1) {
        mkdir("FLUC_direction");
    }
    if(output_histograms == 1) {
        mkdir("FLUC_speed");
    }
    if(output_deflection_time == 1) {
        mkdir("DEFTIME");
    }
    if(output_ts_resamp == 1) {
        mkdir("TS_resamp");
    }
    if(output_autocorrelation == 1) {
        mkdir("AUTOCORR");
    }
    if(output_outlier_subst == 1) {
        mkdir("OUTLIERS_deleted");
    }
       
    
       

    // reception:
    reception(); // -> wt_ts_cond_lib1.h


    if(argc == 1){
        user_instruction2();
    }

    
    // open and read logbook-info file:
    open_read_logbook_info();
    
    // detection of measurement details:
    meas_details(); // -> wt_ts_cond_lib1.h
    measnumber();
    
         // LDA flow measurement:
         if (strcmp(str_meastype, FLOW_MEASUREMENT) == 0 &&
             strcmp(str_insttype, LASER_DOPPLER_ANEMOMETRY) == 0) {

             lda_ts_processing(); // -> wt_ts_cond_modules.h
         }

         // numerical simulation (flow measurement):
         if (strcmp(str_meastype, FLOW_MEASUREMENT) == 0 &&
             strcmp(str_insttype, NUMERICAL_SIMULATION) == 0) {

             lda_ts_processing(); // -> wt_ts_cond_modules.h
         }

    printf("\n Goodbye!\n");     
}


