// LDA_ANALYSIS_2.1_defines
// created: 10-29-2009
// author:  RF
// last modification: 10-29-2009 


#define MEAS_CODE_LENGTH 50
#define NUMBER_STRING 40
#define INPUTSIZE 100
#define DUMMYSTRINGLENGTH 4000
#define WT_REF_LENGTH 50
#define LOGBOOK_INFO_LENGTH 20
#define SPECTRUM 1500000
#define CODESIZE 7
#define MEASNUMBER 3

// wind tunnels
#define BLASIUS "B"
#define WOTAN "W"

// measurements
#define FLOW_MEASUREMENT "FL"

// wind components
#define U_WIND "U"
#define V_WIND "V"
#define W_WIND "W"

// principles of measurement
#define LASER_DOPPLER_ANEMOMETRY "LDA"
#define PARTICLE_IMAGE_VELOCIMETRY "PIV"
#define NUMERICAL_SIMULATION "NUM"
#define CORRELATION "cor"
#define NO_CORRELATION "ncor"

// detecting outliers
#define SIGMAF 4.0

// approximation constants for spectra
#define MAX_BLOCK 200.
// Kaimal
#define A_KAIMAL  16.8
#define B_KAIMAL  33.0
#define C_KAIMAL  1.0
#define D_KAIMAL  1.6666666667
#define E_KAIMAL  1.0
// Simiu and Scanlan
#define A_SIMIUSCANLAN 32.0
#define B_SIMIUSCANLAN 50.0
#define C_SIMIUSCANLAN 1.0
#define D_SIMIUSCANLAN 1.6666666667
#define E_SIMIUSCANLAN 1.0
// von Karman
#define A_KARMAN 4.0
#define B_KARMAN 70.78
#define C_KARMAN 2.0
#define D_KARMAN 0.8333333333
#define E_KARMAN 1.0


// angle time
#define ANGLE 3600
#define MEAN_ANGLE 750000


/****** binary LDA-file ***************/

// file-header
#define ID_SIZE 6
#define POS_LENGTH 16
#define PROJ_LENGTH 128
#define USER_LENGTH 16
#define TS_LENGTH 64

// data-header
#define BLOCK 5

// data
#define SIZE 1500000
#define DEFAULT_VALUE 999.999

#define PI 3.141592654










