// LDA_ANALYSIS_2.1_globalvar
// created: 10-29-2009
// author:  RF
// last modification: 10-29-2009 



// strings from measurement-code
static char meas_code[MEAS_CODE_LENGTH];
static char meas_number_string[MEAS_CODE_LENGTH];
static char first_part[MEAS_CODE_LENGTH];
static char second_part[MEAS_CODE_LENGTH];
static char ts_string[MEAS_CODE_LENGTH];

static char str_01a[MEAS_CODE_LENGTH], str_02a[MEAS_CODE_LENGTH];
static char str_03a[MEAS_CODE_LENGTH], str_04a[MEAS_CODE_LENGTH];
static char str_05a[MEAS_CODE_LENGTH], str_06a[MEAS_CODE_LENGTH];
static char str_07a[MEAS_CODE_LENGTH], str_08a[MEAS_CODE_LENGTH];
static char str_09a[MEAS_CODE_LENGTH], str_10a[MEAS_CODE_LENGTH];
static char str_11a[MEAS_CODE_LENGTH];

static char str_01b[MEAS_CODE_LENGTH], str_02b[MEAS_CODE_LENGTH];
static char str_03b[MEAS_CODE_LENGTH], str_04b[MEAS_CODE_LENGTH];
static char str_05b[MEAS_CODE_LENGTH], str_06b[MEAS_CODE_LENGTH];
static char str_07b[MEAS_CODE_LENGTH], str_08b[MEAS_CODE_LENGTH];
static char str_09b[MEAS_CODE_LENGTH], str_10b[MEAS_CODE_LENGTH];
static char str_11b[MEAS_CODE_LENGTH];



// strings for lda_ts_detection:
static int lda_meas_id, lda_ts_number, lda_ts_startnumber, model_scale, bsa_software_version;
static float lda_scale_factor, ref_height, char_length, rough_el_height;
static float prandtl_layer_min, prandtl_layer_max, reproducibility_comp1, reproducibility_comp2;
static int meas_code_length, start_point, first_length;
static int fft_data;

//switches:
static int output_archiving, output_tecplot;
static int output_statistics, output_timeseries;
static int output_spectrum, output_fluctuations, output_deflection_time;
static int output_histograms, output_ts_resamp, raw_filename_output;
static int output_outlier_subst, output_spec_smooth;
static int output_autocorrelation;
static int out_detec[SIZE], out_delete_index;

// file handles
static char logbook_info_inputfile[INPUTSIZE];
static char lda_ts_inputfile[INPUTSIZE];
static char lda_ts_outputfile[INPUTSIZE];
static char lda_ts_resamp_outputfile[INPUTSIZE];
static char out_file_mean_devel[INPUTSIZE];
static char out_file_stat_raw[INPUTSIZE];
static char out_file_stat_resamp[INPUTSIZE];
static char out_file_tecplot_raw[INPUTSIZE];
static char out_file_tecplot_resamp[INPUTSIZE];
static char out_file_profit_raw[INPUTSIZE];
static char out_file_profit_resamp[INPUTSIZE];
static char out_file_autocorr[INPUTSIZE];
static char out_file_spectrum[INPUTSIZE];
static char out_file_spectrum_easytecplot[INPUTSIZE];
static char out_file_spectrum_smooth_easytecplot[INPUTSIZE];
static char out_file_fluctuations[INPUTSIZE];
static char out_file_fluctuations_easytecplot[INPUTSIZE];
static char out_file_histograms[INPUTSIZE];
static char out_file_histograms_easytecplot[INPUTSIZE];
static char out_file_deflection_time[INPUTSIZE];
static char out_file_deflection_time_easytecplot[INPUTSIZE];
static char out_file_outliers_subst[INPUTSIZE];
static char out_file_statistics[INPUTSIZE];
static char out_file_statistics_easytecplot[INPUTSIZE];
static char out_file_outsubst[INPUTSIZE];
//static char out_file_spectrum[INPUTSIZE];
const char *wt_ref_file_old[INPUTSIZE];
const char *wt_ref_file_new[INPUTSIZE];
static char dummys[DUMMYSTRINGLENGTH];
static int  fh, gh;

//quality
int quality_flag;

// histograms
static int classnumber_speed;

// confidence intervals
static double confidence_interval;


/******************* LDA-file: ****************************/

// file-header
static char header_identity[ID_SIZE];
static int file_header_version; //version of file-header
static int file_header_size;     //size of file-header
static char x_position[POS_LENGTH]; //traverse: x-position
static char y_position[POS_LENGTH]; //  - " -   y-position
static char z_position[POS_LENGTH]; //  - " -   z-position
static char project_name[PROJ_LENGTH];//project name
static int user_name[USER_LENGTH];//user name
static int time_stamp[TS_LENGTH]; //time stamp
static int data_arrays_number;    //number of data arrays

// data-header
static int data_header_version[BLOCK];  //version of data array
static int data_header_size[BLOCK];     //size of data header
static char data_array_name[BLOCK][INPUTSIZE];
static int data_type[BLOCK];    //type of data
static int data_size[BLOCK];    //size of data
static int data_count[BLOCK];   //number of datasamples
static int pos;

// data
static double data_raw[BLOCK][SIZE]; //lda data-matrix 1
static double data_raw_out[BLOCK][SIZE]; //lda data-matrix 2

/***********************************************************/


// indices
static int i;
static int i1;
static int i2;
static int lda_ts_index;
static int j; // -> lda_sample_and_hold -> wt_ts_cond_lda.h
static int jj;
static int k; // -> lda_sample_and_hold -> wt_ts_cond_lda.h

// resampling:
static double data_resam[BLOCK][SIZE]; //lda data-matrix 3
static float time_step_mean;
static int data_count_resam;



/**************** LDA statistics **************************/

static float mean_x[BLOCK], rms_x[BLOCK], conf_x[BLOCK], conf_rms_x[BLOCK];
static float turb_x[BLOCK], skew_x[BLOCK];
static float data_rate_mean;

static float data_raw_comp1_mean_arith, data_raw_comp1_mean_weight;
static float data_raw_comp2_mean_arith, data_raw_comp2_mean_weight;
static float data_resam_comp1_mean_arith, data_resam_comp1_mean_weight;
static float data_resam_comp2_mean_arith, data_resam_comp2_mean_weight;
static float data_raw_comp1_rms_arith, data_raw_comp1_rms_weight;
static float data_raw_comp2_rms_arith, data_raw_comp2_rms_weight;
static float data_resam_comp1_rms_arith, data_resam_comp1_rms_weight;
static float data_resam_comp2_rms_arith, data_resam_comp2_rms_weight;
static float data_raw_comp1_turb_arith, data_raw_comp1_turb_weight;
static float data_raw_comp2_turb_arith, data_raw_comp2_turb_weight;
static float data_resam_comp1_turb_arith, data_resam_comp1_turb_weight;
static float data_resam_comp2_turb_arith, data_resam_comp2_turb_weight;
static float data_raw_comp1_skew_arith, data_raw_comp1_skew_weight;
static float data_raw_comp2_skew_arith, data_raw_comp2_skew_weight;
static float data_resam_comp1_skew_arith, data_resam_comp1_skew_weight;
static float data_resam_comp2_skew_arith, data_resam_comp2_skew_weight;
static float data_raw_comp1_flat_arith, data_raw_comp1_flat_weight;
static float data_raw_comp2_flat_arith, data_raw_comp2_flat_weight;
static float data_resam_comp1_flat_arith, data_resam_comp1_flat_weight;
static float data_resam_comp2_flat_arith, data_resam_comp2_flat_weight;
static float data_raw_comp1_mean_conf_arith, data_raw_comp1_mean_conf_weight;
static float data_raw_comp2_mean_conf_arith, data_raw_comp2_mean_conf_weight;
static float data_resam_comp1_mean_conf_arith, data_resam_comp1_mean_conf_weight;
static float data_resam_comp2_mean_conf_arith, data_resam_comp2_mean_conf_weight;
static float data_raw_comp1_rms_conf_arith, data_raw_comp2_rms_conf_arith;
static float data_resam_comp1_rms_conf_arith, data_resam_comp2_rms_conf_arith;
static float data_raw_comp12_covar_arith, data_raw_comp12_covar_weight;
static float data_resam_comp12_covar_arith, data_resam_comp12_covar_weight;
static float data_raw_comp12_rms_covar_arith;
static float data_resam_comp12_rms_covar_arith;
static float data_raw_comp12_conf_covar_arith;
static float data_resam_comp12_conf_covar_arith;

static float sum_data_resam_2, sum_data_resam_3, mean_data_resam_2, mean_data_resam_3;

static float sum_weight;
static float sum_x[BLOCK], sum_x2[BLOCK];
static float sum_x_x2[BLOCK], sum_x_x3[BLOCK], sum_x_x4[BLOCK];
static float mean_x[BLOCK], rms_x[BLOCK], conf_x[BLOCK];
static float skew_x[BLOCK], flat_x[BLOCK];
static float sum_xy, sum_xy2, covar_xy, rms_covar_xy, conf_covar_xy;

// mean value developing:
static float mean_devel1, mean_devel2, mean_devel3, mean_devel4;

// autocorrelation:
static float RAA[SIZE], raa[SIZE];
static float sum_Ak, sum_Akj, sum_Akkkjkj, sum_Akk, sum_Akjkj;
static float Ak_mean, Akj_mean;
static float sum_jj, sum_RAA, sum_jjRAA, sum_jj2;
static float mean_jj, mean_RAA;
static float dt_autocorr;
static float extrapolation;
static int lag, int_time_steps;

// integral scales
static float integral_time, sum_RAA;
static float t_ux, l_ux;

// spectrum
int FFT_N, blocksize;
char unitString[INPUTSIZE];
double sum_E, sum_sigma_2, exponent;
double X[SPECTRUM], Y[SPECTRUM], E[SPECTRUM], S[SPECTRUM], E_smooth[SPECTRUM], S_smooth[SPECTRUM], f[SPECTRUM], sigma_2;
double LOG_A[SPECTRUM], LOG_B[SPECTRUM], SUM_LOG_A[SPECTRUM], SUM_LOG_B[SPECTRUM], LOG_A_new[SPECTRUM], LOG_B_new[SPECTRUM];
double autoSpectrum[SPECTRUM];
double LOG_KAIMAL[SIZE], SUM_LOG_KAIMAL[SIZE], LOG_KAIMAL_new[SIZE];
double LOG_SIMIU_SCANLAN[SIZE], SUM_LOG_SIMIU_SCANLAN[SIZE], LOG_SIMIU_SCANLAN_new[SIZE];
double LOG_VON_KARMAN[SIZE], SUM_LOG_VON_KARMAN[SIZE], LOG_VON_KARMAN_new[SIZE];

//wind fluctuations
double sum_comp1, sum_comp2, length;
double mean_comp1, mean_comp2, mean_length;
double sum_diff, sum_diff_weight;
double mean_direction;
double direction[SIZE], direction_new[SIZE], direction_diff[SIZE], length_[SIZE], weight_fac[SIZE];
double freq_abs_dir[SIZE], freq_abs_dir_new[SIZE], freq_abs_diff[SIZE], freq_abs_diff_weight[SIZE];
double classwidth_direction, class_center1, class_center2;
double norm[SIZE], sum_direction;
int    classnumber_direction;
int    min_freq_abs;

//fluctuation time
double mean_time[SIZE], mean_time_scaled[SIZE];
double first_direction, second_direction, new_mean_direction;
double angle[ANGLE];
double angle_time[ANGLE][MEAN_ANGLE], sum_angle_time[ANGLE], mean_angle_time[ANGLE];
double angle_time_scaled[ANGLE][MEAN_ANGLE], sum_angle_time_scaled[ANGLE], mean_angle_time_scaled[ANGLE];
int    mean_time_index, mean_time_index_max, angle_index, angle_index_max;
int    success, angle_count[ANGLE];
int count;







/**************** wt ref-file ***************************/

static int    wt_ref_number[WT_REF_LENGTH];
static char   wt_ref_time[WT_REF_LENGTH];
static double wt_ref_trigmean[WT_REF_LENGTH];
static double wt_ref_uref[WT_REF_LENGTH];
static float  u_ref, u_ref_sc;


static char dummy_header[DUMMYSTRINGLENGTH];
static int status;



/**************** logbook-info-file ***************************/

static char logbook_date[MEAS_CODE_LENGTH];
static char info_string[INPUTSIZE][LOGBOOK_INFO_LENGTH];

static char str_maincamp[MEAS_CODE_LENGTH], str_subcamp[MEAS_CODE_LENGTH];
static char str_wt[MEAS_CODE_LENGTH], str_meastype[MEAS_CODE_LENGTH];
static char str_comp1[MEAS_CODE_LENGTH], str_comp2[MEAS_CODE_LENGTH];
static char str_insttype[MEAS_CODE_LENGTH], str_instnumb[MEAS_CODE_LENGTH];
static char str_corr[MEAS_CODE_LENGTH], str_winddir[MEAS_CODE_LENGTH];
static char str_measnumb[MEAS_CODE_LENGTH];





