// LDA_ANALYSIS_2.1_modules
// created: 10-29-2009
// author:  RF
// last modification: 10-29-2009 

// contents:
// 01. lda_ts_processing




/******************************************************
* function    : lda_ts_processing                     *
*-----------------------------------------------------*
* task        : processing lda timeseries             *
* parameter   : no one                                *
* return value: no one                                *
******************************************************/
void lda_ts_processing()
{
    
    lda_ts_index = 0;
    do {
        
        // detection of LDA-timeseries:
        lda_ts_detection(); // -> wt_ts_cond_lda.h
        //printf("LDA-timeseries detected!\n");
        
        // initializing data arrays:
        lda_data_init(); // -> wt_ts_cond_lda.h
        //printf("data arrays initialized!\n");


        

        fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
        if (fh!=-1) {
            close(fh);

            // open and read lda-timeseries:
            open_read_lda_ts(); // -> wt_ts_cond_lda_inputs.h
            //printf("LDA-timeseries opened and read!\n");

            // add quality flag to lda-timeseries:
            quality_flag_function();

            // open and read wt-ref file:
            open_read_ref_file(); // -> wt_ts_cond_lda_inputs.h
            //printf("wt-ref file opened and read!\n");
            
            // substitution of outliers:
            lda_outliers_subst(); // -> wt_ts_cond_lda.h
            
            // calculating mean data rate:
            lda_time_step_mean(); // -> wt_ts_cond_lda.h
            
            // data resampling (sample and hold):
            lda_sample_and_hold(); // -> wt_ts_cond_lda.h
            
            // calculating statistic parameters:
            lda_statistic_parameters(); // -> wt_ts_cond_lda.h
            
            // calculating the autocorrelation of first wind component:
            lda_autocorrelation(data_resam, data_count_resam, 2, 1, str_comp1); // -> wt_ts_cond_lda.h
            
            // calculating integral scales (time and length):
            lda_integral_scales(RAA, dt_autocorr, lag); // -> wt_ts_cond_lda.h
            
            // calculating spectrum:
            if(output_spectrum == 1) {
                lda_spectrum(data_resam, 2, int_time_steps, data_count_resam, str_comp1); // -> wt_ts_cond_lda.h
            }
            
            // calculating wind fluctuations:
            if(output_fluctuations == 1) {
                lda_wind_fluctuation(data_raw, 2, 3); // -> wt_ts_cond_lda.h
                //lda_fluctuation_time_direction();
                //printf("wind direction histograms calculated!\n");
            }

            
            // WRITING ONE TIMESERIES:
            if(output_timeseries == 1) { 
                lda_open_write_file_output_ts(); // -> wt_ts_cond_lda_outputs.h
            }

            if(output_ts_resamp == 1) {
                // WRITING RESAMPLED TIME SERIES
                lda_open_write_file_output_ts_resamp();
            }
            
            // WRITING STATISTICS FILES:
            if(output_statistics == 1) {  
                lda_output_statistic_file(); // -> wt_ts_cond_lda_outputs.h
            }
           
            

            // calculating wind speed histograms
            if(output_histograms == 1) {
                lda_histograms(); // -> wt_ts_cond_lda.h
                //printf("wind speed histograms calculated!\n");
            }

        
            // development of mean values;
            //lda_open_write_file_output_mean_devel();

            
            printf(" LDA-timeseries:  %s processed!\n\n\n", lda_ts_inputfile);

        }
        
        lda_ts_index++;
    } while(lda_ts_index < lda_ts_number);    
    
}    


