// LDA_ANALYSIS_2.1_func2
// created: 10-29-2009
// author:  RF
// last modification: 10-29-2009 



// This library contains functions, used for every kind of measurement!

// contents:
// 01. reception
// 02. strings
// 03. meas_details




/******************************************************
* function    : user_instruction1                     *
*-----------------------------------------------------*
* task        : help for starting the program         *
* parameter   : no one                                *
* return value: no one                                *
******************************************************/
void user_instruction1()
{
    printf("\n\n\n For starting the program enter no more than the following 22 parameters:\n");
    printf(" 1. name of program              : \"FL_ANALYSIS\"\n");
    printf("                                   (the first parameter and must be entered!)\n");
    printf(" 2. name of measurement          : \"meas_c:(char)\"\n");
    printf(" 3. number of timeseries         : \"ts_nbr:(int)\"  (by default: 1)\n");
    printf(" 4. number of first timeseries   : \"ts_stn:(int)\"  (by default: 1)\n");
    printf(" 5. model scale                  : \"ml_scl:(float)\"  (by default: 1 (i.e. 1:1))\n");
    printf(" 6. reference height\n");
    printf("    (model scale [m])            : \"ref_ht:(float)\"  (by default: 1.0 m)\n");
    printf(" 7. scaling factor               : \"sc_fac:(float)\"  (by default: 1.0)\n");
    printf(" 8. characteristic length\n");
    printf("    (model scale [m])            : \"l_char:(float)\"  (by default: 1.0 m)\n");
    printf(" 9. height of roughness elements\n");
    printf("    (model scale [mm])           : \"rel_ht:(float)\"  (by default: 0.0 mm)\n");
    printf("10. lower limit of\n");
    printf("    prandtl-layer height\n");
    printf("    (full scale [m])             : \"pl_min:(float)\"  (by default: 100.0 m)\n");
    printf("11. upper limit of\n");
    printf("    prandtl-layer height\n");
    printf("    (full scale)                 : \"pl_max:(float)\"  (by default: 100.0 m)\n");
    printf("12. confidence interval\n");
    printf("    (statistic analysis)         : \"conf_i:(double)\"  (by default: 95.0 %)\n");
    printf("13. classnumber\n");
    printf("    (frequency distribution of\n");
    printf("     wind direction)             : \"cn_dir:(int)\"  (by default: 360)\n");
    printf("14. classnumber\n");
    printf("    (frequency distribution of\n");
    printf("     wind speed)                 : \"cn_spd:(int))\"  (by default: \"0\")\n");
    printf("15. number of samples for FFT    : \"fft_nn:(int (2^n))\"  (by default: 16384)\n");
    printf("16. reproducability\n");
    printf("    (1st windcomponent)          : \"repro1:(float)\"  (by default: 999.999)\n\n");
    printf("17. reproducability\n"); 
    printf("    (2nd windcomponent)          : \"repro2:(float)\"  (by default: 999.999)\n\n");
    printf("18. switch for output:\n");
    printf("    statistic file               : \"o_stat:(int(1:ON, 0:OFF))\"\n");
    printf("                                   (by default: 1/ON)\n\n");
    printf("19. switch for output:\n");
    printf("    time series                  : \"o_tims:(int(1:ON, 0:OFF))\"\n");
    printf("                                   (by default: 0/OFF)\n\n");
    printf("20. switch for output:\n");
    printf("    TKE-spectrum                 : \"o_spec:(int(1:ON, 0:OFF))\"\n");
    printf("                                   (by default: 0/OFF)\n\n");
    printf("21. switch for output:\n");
    printf("    fluctuation of wind direction: \"o_fluc:(int(1:ON, 0:OFF))\"\n");
    printf("                                   (by default: 0/OFF)\n\n");
    printf("22. switch for output:\n");
    printf("    fluctuation of wind speed    : \"o_hist:(int(1:ON, 0:OFF))\"\n");
    printf("                                   (by default: 0/OFF)\n\n");
    
    printf(" Example:\n");
    printf(" FL_ANALYSIS meas_c:name_of_measurement ts_nbr:10 ts_stn:1 ml_scl:500 ref_ht:0.2 sc_fac:0.8632 l_char:1.5 rel_ht:20.0 pl_min:15.0 pl_max:100.0 conf_i:95.0 cn_dir:360 cn_spd:100 fft_nn:16384 repro1:0.18 repro2:0.15 o_stat:1 o_tims:1 o_spec:1 o_fluc:1 o_hist:1\n\n\n");
}




/******************************************************
* function    : user_instruction2                     *
*-----------------------------------------------------*
* task        : help for starting the program         *
* parameter   : no one                                *
* return value: no one                                *
******************************************************/
void user_instruction2()
{
    char  string2[MEAS_CODE_LENGTH], string3[MEAS_CODE_LENGTH];

    
    string2[0] = '\0';
    printf("Enter the name of the measurement!\n");
    gets(string2);
    strcpy(meas_code, string2);
    printf("measurement: %s\n\n", meas_code);

    
    string2[0] = '\0';
    string3[0] = '\0';
    do { 
        printf("number of time series by default: %i\n", lda_ts_number);
        printf("change it? (y/n)\n");
        gets(string3);
        if(strcmp(string3, "y") == 0 || strcmp(string3, "Y") == 0) {
            printf("Enter the number of time series!\n");
            gets(string2);
            lda_ts_number = atoi(string2);
            printf("number of time series: %i\n\n", lda_ts_number);
        }
        if(strcmp(string3, "n") == 0 || strcmp(string3, "N") == 0) {
            printf("number of time series: %i\n\n", lda_ts_number);
        }
    } while(strcmp(string3, "y") != 0 && strcmp(string3, "Y") != 0 && strcmp(string3, "n") != 0 && strcmp(string3, "N") != 0);
    
    
    string2[0] = '\0';
    string3[0] = '\0';
    do {
        printf("number of the first time series by default: %i\n", lda_ts_startnumber);
        printf("change it? (y/n)\n");
        gets(string3);
        if(strcmp(string3, "y") == 0 || strcmp(string3, "Y") == 0) {
            printf("Enter the number of the first time series!\n");
            gets(string2);
            lda_ts_startnumber = atoi(string2);
            printf("first time series: %i\n\n", lda_ts_startnumber);
        }
        if(strcmp(string3, "n") == 0 || strcmp(string3, "N") == 0) {
            printf("first time series: %i\n\n", lda_ts_startnumber);
        }
    } while(strcmp(string3, "y") != 0 && strcmp(string3, "Y") != 0 && strcmp(string3, "n") != 0 && strcmp(string3, "N") != 0);

    
    string2[0] = '\0';
    string3[0] = '\0';
    do {
        printf("scale by default: %i\n", model_scale);
        printf("change it? (y/n)\n");
        gets(string3);
        if(strcmp(string3, "y") == 0 || strcmp(string3, "Y") == 0) {
            printf("Enter the scale!\n(e.g. for \"1:500\" only enter \"500\")\n");
            gets(string2);
            model_scale = atoi(string2);
            printf("scale: 1:%i\n\n", model_scale);
        }
        if(strcmp(string3, "n") == 0 || strcmp(string3, "N") == 0) {
            printf("scale: 1:%i\n\n", model_scale);
        }
    } while(strcmp(string3, "y") != 0 && strcmp(string3, "Y") != 0 && strcmp(string3, "n") != 0 && strcmp(string3, "N") != 0);

    
    string2[0] = '\0';
    string3[0] = '\0';
    do {
        printf("reference height by default: %5.3lf m\n", ref_height);
        printf("change it? (y/n)\n");
        gets(string3);
        if(strcmp(string3, "y") == 0 || strcmp(string3, "Y") == 0) {
            printf("Enter the reference height (model scale in meters)!\n");
            gets(string2);
            ref_height = atof(string2);
            printf("reference height: %5.3lf m\n\n", ref_height);
        }
        if(strcmp(string3, "n") == 0 || strcmp(string3, "N") == 0) {
            printf("reference height: %5.3lf m\n\n", ref_height);
        }
    } while(strcmp(string3, "y") != 0 && strcmp(string3, "Y") != 0 && strcmp(string3, "n") != 0 && strcmp(string3, "N") != 0);
    
    
    string2[0] = '\0';
    string3[0] = '\0';
    do {
        printf("scale factor by default: %lf\n", lda_scale_factor);
        printf("change it? (y/n)\n");
        gets(string3);
        if(strcmp(string3, "y") == 0 || strcmp(string3, "Y") == 0) {
            printf("Enter the scale factor!\n");
            gets(string2);
            lda_scale_factor = atof(string2);
            printf("scale factor: %lf\n\n", lda_scale_factor);
        }
        if(strcmp(string3, "n") == 0 || strcmp(string3, "N") == 0) {
            printf("scale factor: %lf\n\n", lda_scale_factor);
        }
    } while(strcmp(string3, "y") != 0 && strcmp(string3, "Y") != 0 && strcmp(string3, "n") != 0 && strcmp(string3, "N") != 0);
    
    
    string2[0] = '\0';
    string3[0] = '\0';
    do {
        printf("characteristic length by default: %5.3lf m\n", char_length);
        printf("change it? (y/n)\n");
        gets(string3);
        if(strcmp(string3, "y") == 0 || strcmp(string3, "Y") == 0) {
            printf("Enter the characteristic length (model scale in meters)!\n");
            gets(string2);
            char_length = atof(string2);
            printf("characteristic length: %5.3lf m\n\n", char_length);
        }
        if(strcmp(string3, "n") == 0 || strcmp(string3, "N") == 0) {
            printf("characteristic length: %5.3lf m\n\n", char_length);
        }
    } while(strcmp(string3, "y") != 0 && strcmp(string3, "Y") != 0 && strcmp(string3, "n") != 0 && strcmp(string3, "N") != 0);
    
    
    string2[0] = '\0';
    string3[0] = '\0';
    do {
        printf("height of roughness elements by default: %5.1lf mm\n", rough_el_height);
        printf("change it? (y/n)\n");
        gets(string3);
        if(strcmp(string3, "y") == 0 || strcmp(string3, "Y") == 0) {
            printf("Enter the height of roughness elements (model scale in millimeters)!\n");
            gets(string2);
            rough_el_height = atof(string2);
            printf("height of roughness elements: %5.1lf mm\n\n", rough_el_height);
        }
        if(strcmp(string3, "n") == 0 || strcmp(string3, "N") == 0) {
            printf("height of roughness elements: %5.1lf mm\n\n", rough_el_height);
        }
    } while(strcmp(string3, "y") != 0 && strcmp(string3, "Y") != 0 && strcmp(string3, "n") != 0 && strcmp(string3, "N") != 0);
    
    
    string2[0] = '\0';
    string3[0] = '\0';
    do {
        printf("lower limit of prandtl-layer height by default: %5.3lf m\n", prandtl_layer_min);
        printf("change it? (y/n)\n");
        gets(string3);
        if(strcmp(string3, "y") == 0 || strcmp(string3, "Y") == 0) {
            printf("Enter the lower limit of prandtl-layer height (full scale in meters)!\n");
            gets(string2);
            prandtl_layer_min = atof(string2);
            printf("lower limit of prandtl-layer height: %5.3lf m\n\n", prandtl_layer_min);
        }
        if(strcmp(string3, "n") == 0 || strcmp(string3, "N") == 0) {
            printf("lower limit of prandtl-layer height: %5.3lf m\n\n", prandtl_layer_min);
        }
    } while(strcmp(string3, "y") != 0 && strcmp(string3, "Y") != 0 && strcmp(string3, "n") != 0 && strcmp(string3, "N") != 0);
    

    string2[0] = '\0';
    string3[0] = '\0';
    do {
        printf("upper limit of prandtl-layer height by default: %5.3lf m\n", prandtl_layer_max);
        printf("change it? (y/n)\n");
        gets(string3);
        if(strcmp(string3, "y") == 0 || strcmp(string3, "Y") == 0) {
            printf("Enter the upper limit of prandtl-layer height (full scale in meters)!\n");
            gets(string2);
            prandtl_layer_max = atof(string2);
            printf("upper limit of prandtl-layer height: %5.3lf m\n\n", prandtl_layer_max);
        }
        if(strcmp(string3, "n") == 0 || strcmp(string3, "N") == 0) {
            printf("upper limit of prandtl-layer height: %5.3lf m\n\n", prandtl_layer_max);
        }
    } while(strcmp(string3, "y") != 0 && strcmp(string3, "Y") != 0 && strcmp(string3, "n") != 0 && strcmp(string3, "N") != 0);


    string2[0] = '\0';
    string3[0] = '\0';
    do {
        printf("confidence inteval for statistic analysis by default: %5.1lf %%\n", confidence_interval);
        printf("change it? (y/n)\n");
        gets(string3);
        if(strcmp(string3, "y") == 0 || strcmp(string3, "Y") == 0) {
            printf("Enter the confidence inteval for statistic analysis (in percent)!\n");
            gets(string2);
            confidence_interval = atof(string2);
            printf("confidence inteval for statistic analysis: %5.1lf %%\n\n", confidence_interval);
        }
        if(strcmp(string3, "n") == 0 || strcmp(string3, "N") == 0) {
            printf("confidence inteval for statistic analysis: %5.1lf %%\n\n", confidence_interval);
        }
    } while(strcmp(string3, "y") != 0 && strcmp(string3, "Y") != 0 && strcmp(string3, "n") != 0 && strcmp(string3, "N") != 0);


    string2[0] = '\0';
    string3[0] = '\0';
    do {
        printf("classnumber (freq. dist. of wind direction) by default: %i\n", classnumber_direction);
        printf("change it? (y/n)\n");
        gets(string3);
        if(strcmp(string3, "y") == 0 || strcmp(string3, "Y") == 0) {
            printf("Enter the classnumber (freq. dist. of wind direction)!\n");
            gets(string2);
            classnumber_direction = atoi(string2);
            printf("classnumber (freq. dist. of wind direction): %i\n\n", classnumber_direction);
        }
        if(strcmp(string3, "n") == 0 || strcmp(string3, "N") == 0) {
            printf("classnumber (freq. dist. of wind direction): %i\n\n", classnumber_direction);
        }
    } while(strcmp(string3, "y") != 0 && strcmp(string3, "Y") != 0 && strcmp(string3, "n") != 0 && strcmp(string3, "N") != 0);


    string2[0] = '\0';
    string3[0] = '\0';
    do {
        printf("classnumber (freq. dist. of wind speed) by default: will be calculated!\n");
        printf("change it? (y/n)\n");
        gets(string3);
        if(strcmp(string3, "y") == 0 || strcmp(string3, "Y") == 0) {
            printf("Enter the classnumber (freq. dist. of wind speed)!\n");
            gets(string2);
            classnumber_speed = atoi(string2);
            printf("classnumber (freq. dist. of wind speed): %i\n\n", classnumber_speed);
        }
        if(strcmp(string3, "n") == 0 || strcmp(string3, "N") == 0) {
            printf("classnumber (freq. dist. of wind speed): will be calculated!\n\n");
        }
    } while(strcmp(string3, "y") != 0 && strcmp(string3, "Y") != 0 && strcmp(string3, "n") != 0 && strcmp(string3, "N") != 0);


    string2[0] = '\0';
    string3[0] = '\0';
    do {
        printf("number of samples for FFT by default: %i\n", fft_data);
        printf("change it? (y/n)\n");
        gets(string3);
        if(strcmp(string3, "y") == 0 || strcmp(string3, "Y") == 0) {
            printf("Enter the number of samples for FFT!\n");
            gets(string2);
            fft_data = atoi(string2);
            printf("number of samples for FFT: %i\n\n", fft_data);
        }
        if(strcmp(string3, "n") == 0 || strcmp(string3, "N") == 0) {
            printf("number of samples for FFT: %i\n\n", fft_data);
        }
    } while(strcmp(string3, "y") != 0 && strcmp(string3, "Y") != 0 && strcmp(string3, "n") != 0 && strcmp(string3, "N") != 0);


    string2[0] = '\0';
    string3[0] = '\0';
    do {
        printf("reproducability (1st wind component) by default: %5.3lf m/s\n", reproducibility_comp1);
        printf("change it? (y/n)\n");
        gets(string3);
        if(strcmp(string3, "y") == 0 || strcmp(string3, "Y") == 0) {
            printf("Enter the reproducability (1st wind component) in m/s!\n");
            gets(string2);
            reproducibility_comp1 = atof(string2);
            printf("reproducability (1st wind component): %5.2lf m/s\n\n", reproducibility_comp1);
        }
        if(strcmp(string3, "n") == 0 || strcmp(string3, "N") == 0) {
            printf("reproducability (1st wind component):  n o t   d e f i n e d\n\n");
        }
    } while(strcmp(string3, "y") != 0 && strcmp(string3, "Y") != 0 && strcmp(string3, "n") != 0 && strcmp(string3, "N") != 0);


    string2[0] = '\0';
    string3[0] = '\0';
    do {
        printf("reproducability (2nd wind component) by default: %5.3lf\n", reproducibility_comp2);
        printf("change it? (y/n)\n");
        gets(string3);
        if(strcmp(string3, "y") == 0 || strcmp(string3, "Y") == 0) {
            printf("Enter the reproducability (2nd wind component) in m/s!\n");
            gets(string2);
            reproducibility_comp2 = atof(string2);
            printf("reproducability (2nd wind component): %5.2lf m/s\n\n", reproducibility_comp2);
        }
        if(strcmp(string3, "n") == 0 || strcmp(string3, "N") == 0) {
            printf("reproducability (2nd wind component):  n o t   d e f i n e d\n\n");
        }
    } while(strcmp(string3, "y") != 0 && strcmp(string3, "Y") != 0 && strcmp(string3, "n") != 0 && strcmp(string3, "N") != 0);

    
    string2[0] = '\0';
    string3[0] = '\0';
    do {
        printf("output for statistics by default \"ON\"!\n");
        printf("change it? (y/n)\n");
        gets(string3);
        if(strcmp(string2, "y") == 0 || strcmp(string3, "Y") == 0) {
            output_statistics = 0;
            strcpy(string3, "OFF");
            printf("output for statistics \"OFF\"!\n\n");
        }
        if(strcmp(string3, "n") == 0 || strcmp(string3, "N") == 0) {
            strcpy(string2, "ON");
            printf("output for statistics \"ON\"!\n\n");
        }
    } while(strcmp(string3, "y") != 0 && strcmp(string3, "Y") != 0 && strcmp(string3, "n") != 0 && strcmp(string3, "N") != 0);
    
    
    string2[0] = '\0';
    string3[0] = '\0';
    do {
        printf("output for time series by default \"OFF\"!\n");
        printf("change it? (y/n)\n");
        gets(string3);
        if(strcmp(string3, "y") == 0 || strcmp(string3, "Y") == 0) {
            output_timeseries = 1;
            strcpy(string2, "ON");
            printf("output for time series \"ON\"!\n\n");
        }
        if(strcmp(string3, "n") == 0 || strcmp(string3, "N") == 0) {
            strcpy(string2, "OFF");
            printf("output for time series \"OFF\"!\n\n");
        }
    } while(strcmp(string3, "y") != 0 && strcmp(string3, "Y") != 0 && strcmp(string3, "n") != 0 && strcmp(string3, "N") != 0);
    
    
    string2[0] = '\0';
    string3[0] = '\0';
    do {
        printf("output for spectrum by default \"OFF\"!\n");
        printf("change it? (y/n)\n");
        gets(string3);
        if(strcmp(string3, "y") == 0 || strcmp(string3, "Y") == 0) {
            output_spectrum = 1;
            strcpy(string2, "ON");
            printf("output for spectrum \"ON\"!\n\n");
        }
        if(strcmp(string3, "n") == 0 || strcmp(string3, "N") == 0) {
            strcpy(string2, "OFF");
            printf("output for spectrum \"OFF\"!\n\n");
        }
    } while(strcmp(string3, "y") != 0 && strcmp(string3, "Y") != 0 && strcmp(string3, "n") != 0 && strcmp(string3, "N") != 0);
    
    
    string2[0] = '\0';
    string3[0] = '\0';
    do {
        printf("output for fluctuations of wind-direction by default \"OFF\"!\n");
        printf("change it? (y/n)\n");
        gets(string3);
        if(strcmp(string3, "y") == 0 || strcmp(string3, "Y") == 0) {
            output_fluctuations = 1;
            strcpy(string2, "ON");
            printf("output for fluctuations of wind-direction \"ON\"!\n\n");
        }
        if(strcmp(string3, "n") == 0 || strcmp(string3, "N") == 0) {
            strcpy(string2, "OFF");
            printf("output for fluctuations of wind-direction \"OFF\"!\n\n");
        }
    } while(strcmp(string3, "y") != 0 && strcmp(string3, "Y") != 0 && strcmp(string3, "n") != 0 && strcmp(string3, "N") != 0);
    
    
    string2[0] = '\0';
    string3[0] = '\0';
    do {
        printf("output for fluctuations of wind-speed by default \"OFF\"!\n");
        printf("change it? (y/n)\n");
        gets(string3);
        if(strcmp(string3, "y") == 0 || strcmp(string3, "Y") == 0) {
            output_histograms = 1;
            strcpy(string2, "ON");
            printf("output for fluctuations of wind-speed \"ON\"!\n\n");
        }
        if(strcmp(string3, "n") == 0 || strcmp(string3, "N") == 0) {
            strcpy(string2, "OFF");
            printf("output for fluctuations of wind-speed \"OFF\"!\n\n");
        }
    } while(strcmp(string3, "y") != 0 && strcmp(string3, "Y") != 0 && strcmp(string3, "n") != 0 && strcmp(string3, "N") != 0);
    
    
    string2[0] = '\0';
    string3[0] = '\0';
}




/******************************************************
* function    : reception                             *
*-----------------------------------------------------*
* task        : to greet the user                     *
* parameter   : no one                                *
* return value: no one                                *
******************************************************/
void reception()
{
    printf("\n\n\n *******************************************\n");
    printf(" *     W I N D   T U N N E L - D A T A     *\n");
    printf(" *             A N A L Y S I S             *\n");
    printf(" *                                         *\n");
    printf(" *               FL ANALYSIS               *\n");
    printf(" * --------------------------------------- *\n");
    printf(" * author: R. Fischer                      *\n");
    printf(" * e-mail: rasmus.fischer@zmaw.de          *\n");
    printf(" *******************************************\n\n\n");
}







/***********************************************************
* function    : meas_details                               *
*----------------------------------------------------------*
* task        : detecting details of measurement           *
* parameter   : no one                                     *
* return value: no one                                     *
***********************************************************/
void meas_details()
{
    // Ptrinting deteails of the chosen measurement on the
    // screen:
      
    printf("\n\n main project    : %s\n", str_maincamp);
    printf(" sub project     : %s\n", str_subcamp);
    
    if (strcmp(str_wt, BLASIUS) == 0) {
        printf(" wind tunnel     : Blasius\n\n");
    }
    else if (strcmp(str_wt, WOTAN) == 0) {
        printf(" wind tunnel     : Wotan\n\n");
    }
    else {
        printf(" wind tunnel     : not identifyable!");
          exit(1);
    }
    
    if (strcmp(str_meastype, FLOW_MEASUREMENT) == 0) {
        printf(" measurement     : flow measurement\n");
    }
    else {
        printf(" measurement     : not identifyable!");
          exit(2);
    }

        // only for flow measurements
        if (strcmp(str_meastype, FLOW_MEASUREMENT) == 0) {
            if (strcmp(str_comp1, U_WIND) == 0 ||
                strcmp(str_comp1, V_WIND) == 0 ||
                strcmp(str_comp1, W_WIND) == 0) {
                    printf(" wind component 1: %s\n", str_comp1);
                }
            else {
                printf(" wind component 1: not identifyable!");
                  exit(3);
            }      
            if (strcmp(str_comp2, U_WIND) == 0 ||
                strcmp(str_comp2, V_WIND) == 0 ||
                strcmp(str_comp2, W_WIND) == 0) {
                    printf(" wind component 2: %s\n", str_comp2);
                }
            else {
                printf(" wind component 2: not identifyable!");
                  exit(4);
            }
            
            printf(" wind direction  : %5.1lf deg\n\n", atoi(str_winddir)/10.);    
    
            if (strcmp(str_insttype, LASER_DOPPLER_ANEMOMETRY) == 0) {
                    printf(" principle of measurement: laser doppler anemometry\n");
            }
            else if (strcmp(str_insttype, PARTICLE_IMAGE_VELOCIMETRY) == 0) {
                         printf(" principle of measurement: particle image velocimetry\n");
            }
            else if (strcmp(str_insttype, NUMERICAL_SIMULATION) == 0) {
                         printf(" principle of measurement: numerical simulation\n");
            }
            else {
                printf(" principle of measurement: not identifyable!");
                  exit(5);
            }
            printf(" instrument              : %s\n\n", str_instnumb);

            if (strcmp(str_corr, CORRELATION) == 0) {
                printf("                           correlated measurement\n");
            }
            else if (strcmp(str_corr, NO_CORRELATION) == 0) {
                printf("                           not a correlated measurement\n");
            }
            else {
                printf(" status of correlation not identifyable!");
                  exit(6);
            }  
        }

   
    //printf(" number: %s\n\n\n\n", str_measnumb);

}









/***********************************************************
* function    : measnumber                                 *
*----------------------------------------------------------*
* task        : detecting the number of measurement        *
* parameter   : no one                                     *
* return value: no one                                     *
***********************************************************/
void measnumber()
{
    start_point = 0;
    meas_code_length = strlen(meas_code);

    first_length = meas_code_length - MEASNUMBER;
    strncpy(first_part, meas_code, first_length);

    start_point += first_length;
    first_part[first_length] = '\0';


    strncpy(second_part, (meas_code + start_point), MEASNUMBER);

    strcpy(meas_number_string, second_part);
}
            
                        
                
        
        
     
    


