// LDA_ANALYSIS_2.1_inputs
// created: 10-29-2009
// author:  RF
// last modification: 10-29-2009 



// contents:
// 01. open_read_lda_ts
// 02. open_read_ref_file






/***********************************************************
* function    : open_read_logbook_info                     *
*----------------------------------------------------------*
* task        : to open and read the logbook-info file     *
* parameter   : no one                                     *
* return value: no one                                     *
***********************************************************/
void open_read_logbook_info()
{
    int  i;
    
    sprintf(logbook_info_inputfile, "logbook-info.txt");
    if((fh = fopen(logbook_info_inputfile, "r")) == NULL) {
        printf("\nlogbook-information file aborted!\n");
        exit(8);
    }
    else {
           printf(" logbook-information file opened!\n");

           i = 0;
           while (fgets(dummys, sizeof(dummys), fh) != NULL)
           {
               sscanf(dummys, "%s\n", &info_string[i]);
               i++;
           }

           strcpy(logbook_date, info_string[0]);
           strcpy(str_maincamp, info_string[1]);
           strcpy(str_subcamp, info_string[2]);
           strcpy(str_wt, info_string[3]);
           strcpy(str_meastype, info_string[4]);
           strcpy(str_insttype, info_string[5]);
           strcpy(str_instnumb, info_string[6]);
           strcpy(str_winddir, info_string[7]);
           strcpy(str_comp1, info_string[8]);
           strcpy(str_comp2, info_string[9]);
           strcpy(str_corr, info_string[10]);
    }           
}





/******************************************************
* function    : open_read_lda_ts                      *
*-----------------------------------------------------*
* task        : open and read a binary LDA-timeseries *
* parameter   : no one                                *
* return value: no one                                *
******************************************************/
void open_read_lda_ts()
{
    /********** Open LDA-timeseries ***********************/
    fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
    if (fh==-1) {
        printf("open LDA-timeseries %s aborted!", lda_ts_inputfile);
        exit(2);
    }
    
    /********** Read LDA-timeseries ***********************/

    /********** Read file-header **************************/
    lseek(fh, 0x000, SEEK_SET);
    read(fh, header_identity, sizeof(header_identity)); // read file-header id
    //printf("file header id: %s\n", header_identity);
    lseek(fh, 0x006, SEEK_SET);
    read(fh, &file_header_version, sizeof(file_header_version)); // read file-header version
    //printf("file header version: %i\n", file_header_version);
    lseek(fh, 0x008, SEEK_SET);
    read(fh, &file_header_size, sizeof(file_header_size)); // read file-header size
    //printf("file header size: %i\n", file_header_size);
    lseek(fh, 0x00C, SEEK_SET);
    read(fh, &x_position, sizeof(x_position)); // read traverse x-position
    //printf("x-position: %s\n", x_position);
    lseek(fh, 0x01C, SEEK_SET);
    read(fh, &y_position, sizeof(y_position)); // read traverse y-position
    //printf("y-position: %s\n", y_position);
    lseek(fh, 0x02C, SEEK_SET);
    read(fh, &z_position, sizeof(z_position)); // read traverse z-position
    //printf("z-position: %s\n", z_position);
    lseek(fh, 0x048, SEEK_SET);
    read(fh, &project_name, sizeof(project_name)); // read project name
    //printf("project name: %s\n", project_name);
    lseek(fh, 0x0C8, SEEK_SET);
    read(fh, &user_name, sizeof(user_name)); // read user name
    //printf("user name: %s\n", user_name);
    lseek(fh, 0x0D8, SEEK_SET);
    read(fh, &time_stamp, sizeof(time_stamp)); // read time stamp
    //printf("time stamp: %s\n", time_stamp);
    lseek(fh, 0x158, SEEK_SET);
    read(fh, &data_arrays_number, sizeof(data_arrays_number)); // read number of data arrays
    //printf("data arrays number: %i\n", data_arrays_number);

           /**** provisorische Lsung des Header-Problems in der neuen BSA-Software ****/
                             data_arrays_number = 4;
           /****************************************************************************/
                             
    //printf("file-header read!\n");
        
    /********** Read data blocks **************************/

    // block0: arrival time (AT)
    // block1: transition time (TT)
    // block2: first wind component
    // block3: second wind component
    
    i     = 0;
    pos   = file_header_size;
    do {
        /****** Read data-header **************************/
        lseek(fh, pos + 0x000, SEEK_SET);
        read(fh, &data_header_version[i], sizeof(data_header_version[i])); // read data-header version
        //printf("data header version: %i\n", data_header_version[i]);
        lseek(fh, pos + 0x002, SEEK_SET);
        read(fh, &data_header_size[i], sizeof(data_header_size[i])); // read data-header size
        //printf("data header size: %i\n", data_header_size[i]);
        lseek(fh, pos + 0x006, SEEK_SET);
        read(fh, &data_array_name[i], sizeof(data_array_name[i])); // read data-array name
        //printf("data arrays name: %s\n", data_array_name[i]);
        lseek(fh, pos + 0x04A, SEEK_SET);
        read(fh, &data_type[i], sizeof(data_type[i])); // read data type
        //printf("data type: %i\n", data_type[i]);
        lseek(fh, pos + 0x04E, SEEK_SET);
        read(fh, &data_size[i], sizeof(data_size[i])); // read data size
        //printf("data size: %i\n", data_size[i]);
        lseek(fh, pos + 0x052, SEEK_SET);
        read(fh, &data_count[i], sizeof(data_count[i])); // read number of data samples
        //printf("data count: %i\n", data_count[i]);
        
        //printf("data-header %i read!\n", i);
        
        /****** Read data *********************************/
        lseek(fh, pos + data_header_size[i], SEEK_SET);
        read(fh, data_raw[i], data_size[i]*data_count[i]);
    
        pos = pos + data_header_size[i] + data_size[i]*data_count[i];
        i++;
        
    } while (i < data_arrays_number);
    
        
    if(data_count[0]!=data_count[1] ||
       data_count[0]!=data_count[2] ||
       data_count[0]!=data_count[3]) {
        printf("%i\n%i\n%i\n%i\n", data_count[0], data_count[1], data_count[2], data_count[3]);   
        printf("unequal data counts!!!/a/a/a\n");
        exit(3);
    }
    
    close(fh);

    printf("\n\n\n input-file: \"%s\" read!\n", lda_ts_inputfile);
     
}





/******************************************************
* function    : open_read_ref_file                    *
*-----------------------------------------------------*
* task        : opening ref-file and reading reference*
*               wind speed                            *
* parameter   : no one                                *
* return value: no one                                *
******************************************************/
void open_read_ref_file()
{
    sprintf(wt_ref_file_old, "%s_wtref.txt", meas_code);
    
    if((fh = fopen(wt_ref_file_old, "r")) == NULL) {
        printf("\n opening ref-file: %s aborted!\n", wt_ref_file_old);
        exit(4);
    }
    else {
           printf(" ref-file: %s opened!\n", wt_ref_file_old);
    }          
    
    i = 1;
    if (fgets(dummys, sizeof(dummys), fh) != NULL) {
        sscanf("%s\n", dummy_header);
    }
  
    while (fgets(dummys, sizeof(dummys), fh) != NULL)
    {
        sscanf(dummys, "%i %s %lf %lf\n",
               &wt_ref_number[i], &wt_ref_time[i], &wt_ref_trigmean[i],
               &wt_ref_uref[i]);
        i++;
    }

    u_ref = wt_ref_uref[lda_ts_startnumber+lda_ts_index];

    printf(" U (prandtl-tube): %5.2lf m/s\n", u_ref);
    printf(" U (reference)   : %5.2lf m/s\n", u_ref * lda_scale_factor);
        
    close(fh);
    
    sprintf(wt_ref_file_new, "%s_%s_%s_%s_%s_%s_%s_wtref.txt",
                             str_maincamp, str_subcamp, str_wt, str_meastype,
                             str_comp1, str_comp2, str_measnumb);

    status = rename(wt_ref_file_old, wt_ref_file_new);

}


